/*
 __  __                  _               _               _ 
|  \/  | ___  __ _  __ _| |__   __ _ ___| |_ ___ _ __ __| |
| |\/| |/ _ \/ _` |/ _` | '_ \ / _` / __| __/ _ \ '__/ _` |
| |  | |  __/ (_| | (_| | |_) | (_| \__ \ ||  __/ | | (_| |
|_|  |_|\___|\__, |\__,_|_.__/ \__,_|___/\__\___|_|  \__,_|
             |___/                                         
© Perpetrated by tonikelope since 2016
 */
package com.tonikelope.megabasterd;

import java.util.concurrent.ConcurrentHashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

//https://github.com/tonikelope/megabasterd/issues/397

/*
    THANK YOU VERY MUCH TO:

    (ITALIAN) https://github.com/bovirus

    (CHINESE) https://github.com/linkea131

    (HUNGARIAN) https://github.com/Roschach96

    (GERMAN) https://github.com/NieckLikesCode
    
    (TURKISH) https://github.com/FabrieI

    (VIETNAMESE) https://github.com/rattybox

 */
public class LabelTranslatorSingleton {

    private static final Logger LOG = Logger.getLogger(LabelTranslatorSingleton.class.getName());

    public static LabelTranslatorSingleton getInstance() {

        return LabelTranslatorSingleton.LazyHolder.INSTANCE;
    }

    private final ConcurrentHashMap<String, String> _rosetta;

    private LabelTranslatorSingleton() {

        _rosetta = new ConcurrentHashMap();

        switch (MainPanel.getLanguage()) {

            case "CH":
                Chinese();
                break;

            case "GE":
                German();
                break;

            case "HU":
                Hungarian();
                break;

            case "IT":
                Italian();
                break;

            case "ES":
                Spanish();
                break;

            case "TU":
                Turkish();
                break;

            case "VI":
                Vietnamese();
                break;
        }

    }

    private void German() {
        _addTranslation("COPY ALL", "ALLE KOPIEREN");
        _addTranslation("ALL COPIED!", "ALLES KOPIERT!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "EINE DATEI MIT DEMSELBEN NAMEN UND DATEIGRÖßE EXISTIERT BEREITS");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "WARNUNG: DIE MEGA API OHNE EINEN API-SCHLÜSSEL ZU BENUTZEN KÖNNTE GEGEN DIE NUTZUNGSBEDINGUNGEN VERSTOßEN. SIE SOLLTEN EINEN SCHLÜSSEL BEANTRAGEN -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "WARNUNG: DIE MEGA API OHNE EINEN API-SCHLÜSSEL ZU BENUTZEN KÖNNTE GEGEN DIE NUTZUNGSBEDINGUNGEN VERSTOßEN. \n\n SIE SOLLTEN EINEN SCHLÜSSEL BEANTRAGEN ->  https://mega.nz/sdk (UND IHN IN DEN MegaBasterd ERWEITERTEN EINSTELLUNGEN FESTLEGEN).\n\nJETZT EINEN API-SCHLÜSSEL ERSTELLEN?");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "WARNUNG: DIE VERWENDUNG VON PROXYS ODER VPN-ANBIETERN ZUR UMGEHUNG DER TÄGLICHEN DOWNLOAD-BESCHRÄNKUNGEN KANN GEGEN DIE NUTZUNGSBEDINGUNGEN VERSTOßEN. NUTZEN SIE DIESE OPTION AUF EIGENES RISIKO HIN:");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "DIE VERWENDUNG VON PROXYS ODER VPN-ANBIETERN ZUR UMGEHUNG DER TÄGLICHEN DOWNLOAD-BESCHRÄNKUNGEN KANN GEGEN DIE NUTZUNGSBEDINGUNGEN VERSTOßEN.\n\n NUTZEN SIE DIESE OPTION AUF EIGENES RISIKO HIN.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "Führen Sie diesen Befehl aus, wenn das Mega-Download-Limit erreicht ist:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "Nutze diese Proxy Liste (anstelle der in MegaBasterd enthaltenen Liste) Format ist [*]IP:PORT[@user_b64:passwort_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "Warte auf den Abschluss-Handler ... *** MEGABASTARD JETZT NICHT VERLASSEN ***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "Beenden der Berechnung des CBC-MAC-Codes (dies kann eine Weile dauern) ... *** MEGABASTERD JETZT NICHT BEENDEN ***");
        _addTranslation("Split content in different uploads", "Inhalt in verschiedene Uploads aufteilen");
        _addTranslation("Merge content in the same upload", "Inhalte im selben Upload zusammenführen");
        _addTranslation("How do you want to proceed?", "Wie wollen Sie fortfahren?");
        _addTranslation("Put on TOP of waiting queue", "OBEN in die Warteschlange stellen");
        _addTranslation("TOP", "OBEN");
        _addTranslation("BOTTOM", "UNTEN");
        _addTranslation("Freeze transferences before start", "Übertragungen vor dem Start einfrieren");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "WARTENDE ÜBERTRAGUNGEN FREIGEBEN");
        _addTranslation("(FROZEN) Waiting to start...", "(EINGEFROREN) Warte auf Start...");
        _addTranslation("(FROZEN) Waiting to start (", "(EINGEFROREN) Warte auf Start (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Es sind viele Dateien in diesem Ordner.\nNicht alle Links werden auf einmal bereitgestellt, um MegaBasterd nicht zu überlasten");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Sie haben zu oft versucht, sich anzumelden. Warten Sie eine Stunde.");
        _addTranslation("MEGA LINK ERROR!", "MEGA LINK FEHLER!");
        _addTranslation("Please enter 2FA PIN CODE", "Geben Sie bitte ihre 2FA Geheimzahl ein");
        _addTranslation("Enable log file", "Protokolldatei aktivieren");
        _addTranslation("Font:", "Schriftart:");
        _addTranslation("Loading...", "Lade...");
        _addTranslation("DEFAULT", "STANDARD");
        _addTranslation("ALTERNATIVE", "ALTERNATIV");
        _addTranslation("Download latest version", "Neuste Version herunterladen");
        _addTranslation("PROVISION FAILED", "BEREITSTELLUNG FEHLGESCHLAGEN");
        _addTranslation("Error registering download: file is already downloading.", "Fehler beim registrieren des Downloads: die Datei wird bereits heruntergeladen.");
        _addTranslation("FATAL ERROR! ", "FATALER FEHLER!");
        _addTranslation("ERROR: FILE NOT FOUND", "FEHLER: DATEI KONNTE NICHT GEFUNDEN WERDEN");
        _addTranslation("Mega link is not valid! ", "Mega link ist nicht valide!");
        _addTranslation("Checking your MEGA accounts, please wait...", "Überprüfung ihrer Mega-Konten, bitte warten Sie...");
        _addTranslation("Check for updates", "Auf Updates prüfen");
        _addTranslation("Checking, please wait...", "Prüfe, bitte warten Sie...");
        _addTranslation("You have the latest version ;)", "Sie verfügen über die neuste Version ;)");
        _addTranslation("Copy MegaBasterd download URL", "Kopiere MegaBasterd Download-URL");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Mit Liebe (und ohne Garantie) von tonikelope gemacht.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Eine weiterer (und hässlicher) plattformübergreifender MEGA downloader/uploader/streaming dienst");
        _addTranslation("MEGA URL was copied to clipboard!", "MEGA URL wurde in die Zwischenablage kopiert!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "Eine NEUE MEGABASTERD VERSION ist erhältlich! -> ");
        _addTranslation("Selecting folder...", "Ordner auswählen...");
        _addTranslation("MERGE FILE", "DATEI ZUSAMMENFÜHREN");
        _addTranslation("Delete parts after merge", "Teile nach dem Zusammenführen löschen");
        _addTranslation("Remove selected", "Ausgewältes löschen");
        _addTranslation("SPLIT FILE", "DATEI AUFTEILEN");
        _addTranslation("Encrypt on disk sensitive information", "Vertrauliche Informationen auf der Festplatte verschlüsseln");
        _addTranslation("Allow using MEGA accounts for download/streaming", "Verwendung von MEGA-Konten zum Herunterladen/Streamen zulassen");
        _addTranslation("Please wait...", "Warten Sie bitte...");
        _addTranslation("CANCEL RETRY", "WIEDERHOLUNG ABBRECHEN");
        _addTranslation("SPLITTING FILE...", "TEILE DATEI AUF...");
        _addTranslation("Open folder", "Ordner öffnen");
        _addTranslation("RESUME DOWNLOAD", "Download fortsetzen");
        _addTranslation("Close", "Schließen");
        _addTranslation("Add files", "Dateien hinzufügen");
        _addTranslation("IMPORT SETTINGS", "Einstellungen importieren");
        _addTranslation("RESET MEGABASTERD", "MEGABASTERD ZURÜCKSETZEN");
        _addTranslation("RESET ACCOUNTS", "KONTEN ZURÜCKSETZEN");
        _addTranslation("Verify file integrity (when download is finished)", "Überprüfe die Dateiintegrität (wenn der Download abgeschlossen ist)");
        _addTranslation("Let's dance, baby", "Lass uns loslegen");
        _addTranslation("Unlock accounts", "Konten entsperren");
        _addTranslation("Use MegaCrypter reverse mode", "MegaCrypter reverse mode benutzen");
        _addTranslation("Select (any) file part", "Wählen Sie (einen beliebigen) Dateiteil aus");
        _addTranslation("Add folder", "Ordner hinzufügen");
        _addTranslation("Adding files, please wait...", "Füge Dateien hinzu, warten Sie bitte...");
        _addTranslation("Restart", "Neustarten");
        _addTranslation("Use SmartProxy", "SmartProxy benutzen");
        _addTranslation("PAUSE DOWNLOAD", "DOWNLOAD PAUSIEREN");
        _addTranslation("Change it", "Ändern");
        _addTranslation("EXPORT SETTINGS", "EINSTELLUNGEN EXPORTIEREN");
        _addTranslation("Change output folder", "Ausgabeordner ändern");
        _addTranslation("Add account", "Konto hinzufügen");
        _addTranslation("Select file", "Datei auswählen");
        _addTranslation("Opening file...", "Öffne Datei...");
        _addTranslation("CANCEL DOWNLOAD", "DOWNLOAD ABBRECHEN");
        _addTranslation("REMOVE ALL EXCEPT THIS", "ALLE AUßER DIESES ENTFERNEN");
        _addTranslation("Loading DLC, please wait...", "Lade DLC, warten Sie bitte...");
        _addTranslation("Changing output folder...", "Ändere Ausgabeordner...");
        _addTranslation("RESUME UPLOAD", "UPLOAD FORTSETZEN");
        _addTranslation("Limit upload speed", "Uploadgeschwindigkeit begrenzen");
        _addTranslation("CANCEL", "ABBRECHEN");
        _addTranslation("Use multi slot download mode", "Verwende Multi-Slot-Download-Modus");
        _addTranslation("Selecting file...", "Wähle Datei aus...");
        _addTranslation("Copy folder link", "Ordnerlink kopieren");
        _addTranslation("Limit download speed", "Downloadgeschwindigkeit limitieren");
        _addTranslation("REMOVE THIS", "DIESES OBJEKT ENTFERNEN");
        _addTranslation("Copy file link", "Dateilink kopieren");
        _addTranslation("Load DLC container", "DLC-Container laden");
        _addTranslation("Adding folder, please wait...", "Füge Ordner hinzu, warten Sie bitte...");
        _addTranslation("PAUSE UPLOAD", "UPLOAD PAUSIEREN");
        _addTranslation("CANCEL CHECK", "ÜBERPRÜFUNG ABBRECHEN");
        _addTranslation("Keep temp file", "TEMP-DATEI BEHALTEN");
        _addTranslation("Use HTTP(S) PROXY", "HTTP(S) PROXYS BENUTZEN");
        _addTranslation("MERGING FILE...", "DATEI WIRD ZUSAMMENGEFÜHRT...");
        _addTranslation("Checking MEGA account...", "Überprüfe MEGA Konto...");
        _addTranslation("SAVE", "SPEICHERN");
        _addTranslation("New download", "NEUER DOWNLOAD");
        _addTranslation("New upload", "NEUER UPLOAD");
        _addTranslation("New streaming", "NEUER STREAM");
        _addTranslation("Split file", "DATEI AUFTEILEN");
        _addTranslation("Merge file", "DATEI ZUSAMMENFÜHREN");
        _addTranslation("Remove all no running downloads", "Alle nicht laufenden Downloads entfernen");
        _addTranslation("Remove all no running uploads", "Alle nicht laufenden Uploads entfernen");
        _addTranslation("Edit", "Bearbeiten");
        _addTranslation("Settings", "Einstellungen");
        _addTranslation("Help", "Hilfe");
        _addTranslation("About", "Über");
        _addTranslation("Remember for this session", "Für diese Session speichern");
        _addTranslation("Restore folder data", "Ordnerdaten wiederherstellen");
        _addTranslation("Restoring data, please wait...", "Stelle Daten wiederher, warten Sie bitte...");
        _addTranslation("File", "Datei");
        _addTranslation("Hide to tray", "In den Tray minimieren");
        _addTranslation("Clear finished", "Fertige Objekte entfernen");
        _addTranslation("Exit", "Verlassen");
        _addTranslation("Default slots per file:", "Standard-Slots pro Datei:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Hinweis: Wenn Sie ohne ein MEGA PREMIUM KONTO download wollen, solltne sie diese Option aktivieren. (Slots verbrauchen RAM, verwenden Sie sie also in Maßen).");
        _addTranslation("Max speed (KB/s):", "Maximale Geschwindigkeit (KB/s):");
        _addTranslation("Default account:", "Standard Konto:");
        _addTranslation("TCP Port:", "TCP Port:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Hinweis: Sie MÜSSEN diesen Port in ihrem Router/Firewall \"ÖFFNEN\"");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Hinweis: Aktivieren Sie diese Option, um das Bandbreitenlimit zu verringern. (Multi-Slot erforderlich).");
        _addTranslation("Max parallel downloads:", "Maximale parallele Downloads:");
        _addTranslation("Max parallel uploads:", "Maximale parallele Uploads:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Hinweis: Slots verbrauchen RAM, nutzen Sie sie also in Maßen");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Hinweis: Sie können einen (optionalen) Alias für Ihre E-Mail-Adressen verwenden -> bob@supermail.com#bob_mail (vergessen Sie nicht, nach Eingabe Ihrer Konten zu speichern)");
        _addTranslation("Your MEGA accounts:", "Ihre MEGA Konten:");
        _addTranslation("Your ELC accounts:", "IHRE ELC Konten:");
        _addTranslation("Note: restart required.", "Hinweis: Neustart benötigt");
        _addTranslation("Note: restart might be required.", "Hinweis: Möglicherweise ist ein Neustart erforderlich.");
        _addTranslation("Font ZOOM (%):", "Schriftart ZOOM (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Hinweis: MegaBasterd wird diese Proxy für ALLE Verbindungen benutzen.");
        _addTranslation("Port:", "Port:");
        _addTranslation("Settings successfully saved!", "Einstellungen erfolgreich gespeichert!");
        _addTranslation("Settings successfully imported!", "Einstellungen erfolgreich importiert!");
        _addTranslation("Settings successfully exported!", "Einstellungen erfolgreich exportiert!");
        _addTranslation("Settings successfully reset!", "Einstellungen erfolgreich zurückgesetzt");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Bei einigen Accounts sind Fehler aufgetreten (E-Mail und/oder Passwort sind/ist falsch). Bitte überprüfen Sie sie:\n\n");
        _addTranslation("Settings saved", "Einstellungen gespeichert");
        _addTranslation("Settings imported", "Einstellungen importiert");
        _addTranslation("Settings exported", "Einstellungen exportiert");
        _addTranslation("Settings reset", "Einstellungen zurückgesetzt");
        _addTranslation("MegaBasterd will restart", "MegaBasterd wird neugestartet");
        _addTranslation("Restart required", "Neustart benötigt");
        _addTranslation("File is not readable!", "Datei ist nicht lesbar!");
        _addTranslation("Folder is not readable!", "Ordner ist nicht lesbar!");
        _addTranslation("BAD PASSWORD!", "FALSCHES PASSWORT!");
        _addTranslation("Passwords does not match!", "Passwörter stimmen nicht überein");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Geben Sie bitte einen Mega/MegaCrypter/ELC Link ein!");
        _addTranslation("Yes", "Ja");
        _addTranslation("Cancel", "Abbrechen");
        _addTranslation("UNEXPECTED ERROR!", "UNERWARTETER FEHLER!");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "Es scheint, dass MegaBasterd Videos streamt. Möchtest du aussteigen?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "Es scheint, dass MegaBasterd Down/Uploads bereitstellt.\n\nWenn Sie jetzt beenden, gehen nicht bereitgestellte Down/Uploads verloren.\n\nMöchten Sie fortfahren?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "Anscheinend schließt MegaBasterd gerade das Hochladen einiger Dateien ab.\n\nWENN SIE JETZT BEENDEN, WIRD DAS HOCHLADEN FEHLSCHLAGEN.\n\nMöchten Sie fortfahren?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Alle Ihre aktuellen Einstellungen und Konten werden nach dem Import gelöscht. (Es wird empfohlen, Ihre aktuellen Einstellungen vor dem Import zu exportieren). \n\nMöchtest Sie fortfahren?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Nur GESPEICHERTE Einstellungen und Konten werden exportiert. (Wenn Sie sich nicht sicher sind, ist es besser, Ihre aktuellen Einstellungen zu speichern und sie dann zu exportieren).\n\nMöchten Sie fortfahren?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "Master-Passwort wird zurückgesetzt und alle deine Konten werden gelöscht. (DIES KANN NICHT RÜCKGÄNGIG GEMACHT WERDEN)\n\nMöchten Sie fortfahren?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "ALLE IHRE EINSTELLUNGEN, KONTEN UND ÜBERTRAGUNGEN WERDEN ENTFERNT. (Dies kann nicht rückgängig gemacht werden)\n\nMöchten Sie fortfahren?");
        _addTranslation("Remove all no running downloads?", "Alle nicht laufenden Downloads entfernen?");
        _addTranslation("Warning!", "Warnung!");
        _addTranslation("Remove all no running uploads?", "Alle nicht laufenden Uploads entfernen?");
        _addTranslation("Please, enter your master password", "Bitte geben Sie Ihr Master-Passwort ein");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "ACHTUNG: Wenn Sie dieses Passwort vergessen, müssen Sie alle Ihre Konten erneut eingeben.");
        _addTranslation("New pass:", "Neues Passwort:");
        _addTranslation("Confirm new:", "Neu bestätigen:");
        _addTranslation("Verifying your password, please wait...", "Passwort bestätigen, warten Sie bitte...");
        _addTranslation("Processing your password, please wait...", "Ihr Passwort wird verarbeitet, warten Sie bitte...");
        _addTranslation("Downloads", "Downloads");
        _addTranslation("Uploads", "Uploads");
        _addTranslation("Accounts", "Konten");
        _addTranslation("Advanced", "Erweitert");
        _addTranslation("Language:", "Sprache");
        _addTranslation("English", "Englisch");
        _addTranslation("Spanish", "Spanisch");
        _addTranslation("Loading files, please wait...", "Dateien werden geladen, bitte warten...");
        _addTranslation("Checking account quota, please wait...", "Kontokontingent prüfen, bitte warten...");
        _addTranslation("ERROR checking account quota!", "FEHLER beim überprüfen ihres Kontokontigenten!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Wenn Sie einen Ordner oder eine Datei NICHT übertragen möchten, können Sie sie ENTFERNEN (um mehrere Elemente gleichzeitig auszuwählen, verwenden Sie STRG + LMAUS).");
        _addTranslation("Upload name:", "Upload Name:");
        _addTranslation("Account:", "Konto:");
        _addTranslation("Folder link detected!", "Ordnerlink erkannt!");
        _addTranslation("File already exists!", "Datei existiert bereits!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "Megabasterd stoppt Übertragungen sicher, warten Sie bitte...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "Fügen Sie hier Ihren/Ihre MEGA/MegaCrypter/ELC-Link(s) ein (einer pro Zeile):");
        _addTranslation("Download folder:", "Download Ordner:");
        _addTranslation("Split size (MBs):", "Split-Größe (MB):");
        _addTranslation("File successfully splitted!", "Datei erfolgreich aufgeteilt!");
        _addTranslation("File successfully merged!", "Datei erfolgreich zusammengeführt!");
        _addTranslation("File successfuly downloaded!", "Datei erfolgreich heruntergeladen!");
        _addTranslation("Download paused!", "Download pausiert!");
        _addTranslation("Downloading file from mega ...", "Datei von Mega herunterladen ...");
        _addTranslation("Copy link", "Link kopieren");
        _addTranslation("Downloading file from mega ", "Lade Datei von Mega herunter");
        _addTranslation("EXIT NOW", "JETZT ABBRECHEN");
        _addTranslation("Download CANCELED!", "Download ABGEBROCHEN!");
        _addTranslation("Upload CANCELED!", "Upload ABGEBROCHEN!");
        _addTranslation("Uploading file to mega (", "Hochladen einer Datei auf Mega (");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Fügen Sie Ihren MEGA/MegaCrypter/ELC-Link hier ein, um einen Streaming-Link zu erhalten:");
        _addTranslation("Use this account for streaming:", "Verwenden Sie dieses Konto zum Streamen:");
        _addTranslation("Use this account for download:", "Verwenden Sie dieses Konto zum Herunterladen:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "Der Streaming-Link wurde in die Zwischenablage kopiert!\nDenken Sie daran, MegaBasterd im Hintergrund laufen zu lassen, während Inhalte wiedergegeben werden.");
        _addTranslation("CANCEL UPLOAD", "UPLOAD ABBRECHEN");
        _addTranslation("Upload paused!", "Upload pausiert!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "Download wird sicher beendet, bevor MegaBasterd beendet wird, warten Sie bitte...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "Hochladen wird sicher beendet, bevor MegaBasterd beendet wird, warten Sie bitte...");
        _addTranslation("Starting download, please wait...", "Starte Download, warten Sie bitte...");
        _addTranslation("Starting upload, please wait...", "Starte Upload, warten Sie bitte");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "Download wird gestartet (MEGA Temp Link wird abgerufen), warten Sie bitte...");
        _addTranslation("File exists, resuming download...", "Datei existiert, Download wird fortgesetzt...");
        _addTranslation("Truncating temp file...", "Temp-Datei wird abgeschnitten...");
        _addTranslation("Waiting to check file integrity...", "Warten auf Integritätsprüfung der Datei...");
        _addTranslation("Checking file integrity, please wait...", "Dateiintegrität wird geprüft, warten Sie bitte...");
        _addTranslation("Provisioning download, please wait...", "Download wird bereitgestellt, warten Sie bitte...");
        _addTranslation("Waiting to start...", "Warte auf Start...");
        _addTranslation("Provisioning upload, please wait...", "Upload wird bereitgestellt, warten Sie bitte...");
        _addTranslation("Waiting to start (", "Warte auf Start (");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Neuen MEGA-Knoten erstellen ... *** MEGABASTERD JETZT NICHT BEENDEN ***");
        _addTranslation("File successfully uploaded! (", "Datei erfolgreich hochgeladen! (");
        _addTranslation("PAUSE ALL", "ALLE PAUSIEREN");
        _addTranslation("RESUME ALL", "ALLE FORTSETZEN");
        _addTranslation("MEGA folder link was copied to clipboard!", "Link zum MEGA-Ordner wurde in die Zwischenablage kopiert!");
        _addTranslation("MEGA file link was copied to clipboard!", "Link zur MEGA-Datei wurde in die Zwischenablage kopiert!");
        _addTranslation("Pausing download ...", "Pausiere Download");
        _addTranslation("Pausing upload ...", "Pausiere Upload");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "Datei erfolgreich heruntergeladen! (Integritätsprüfung BESTANDEN)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "Datei erfolgreich heruntergeladen! (aber Integritätsprüfung ABGEBROCHEN)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "UPLOAD FEHLGESCHLAGEN! (Leerer Completion-Handler!)");
        _addTranslation("UPLOAD FAILED: too many errors", "UPLOAD FEHLGESCHLAGEN: zu viele Fehler");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "UPLOAD ABGEBROCHEN: Fataler Fehler");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "SCHLECHTE NACHRICHTEN :( Datei ist BESCHÄDIGT!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "MEGA LINK VORÜBERGEHEND NICHT VERFÜGBAR!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "Datei vorübergehend nicht verfügbar! (Versuche erneut in ");
        _addTranslation(" secs...)", " Sekunden...");
        _addTranslation(" (Retrying in ", " (Versuche erneut in ");
        _addTranslation("Proxy settings", "Proxy Einstellungen");
        _addTranslation("Authentication", "Authentifizierung");
        _addTranslation("Upload info", "Informationen hochladen");
        _addTranslation("Files", "Dateien");
        _addTranslation("Username:", "Nutzername:");
        _addTranslation("Password:", "Passwort:");
        _addTranslation("Link was copied to clipboard!", "Link wurde in die Zwischenablage kopiert!");
        _addTranslation("Checking if there are previous downloads, please wait...", "Es wird geprüft, ob es frühere Downloads gibt, warten Sie bitte...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Es wird geprüft, ob es frühere Uploads gibt, warten Sie bitte...");
        _addTranslation("Restore window", "Fenster wiederherstellen");
        _addTranslation("EXIT", "SCHLIEßEN");
        _addTranslation("File successfully downloaded!", "Datei erfolgreich heruntergeladen!");
        _addTranslation("Quota used: ", "Genutztes Kontingent: ");
        _addTranslation("Streaming server: ON (port ", "Streaming-Server: EIN (Port");
        _addTranslation("MC reverse mode: ON (port ", "MC-Umkehrmodus: EIN (Port");
        _addTranslation("Joining file chunks, please wait...", "Dateiblöcke werden zusammengefügt, bitte warten...");
        _addTranslation("Close MegaBasterd when all transfers finish", "Schließen Sie MegaBasterd, wenn alle Übertragungen abgeschlossen sind");
        _addTranslation("Use custom temporary directory for chunks storage", "Verwenden Sie ein benutzerdefiniertes temporäres Verzeichnis für die Chunks-Speicherung");
        _addTranslation("CANCEL ALL DOWNLOADS", "CANCEL ALL DOWNLOADS");
        _addTranslation("Save debug info to file", "Save debug info to file");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "Slots");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Pre:", "Pre:");
        _addTranslation("Pro:", "Pro:");
        _addTranslation("Wait:", "Wait:");
        _addTranslation("Run:", "Run:");
        _addTranslation("Finish:", "Finish:");
        _addTranslation("Rem:", "Rem:");
        _addTranslation("Italian", "Italian");
        _addTranslation("Chinese", "Chinese");
        _addTranslation("German", "German");
        _addTranslation("Hungarian", "Hungarian");
        _addTranslation("Turkish", "Turkish");
        _addTranslation("Streaming server: OFF (port ", "Streaming server: OFF (port ");
        _addTranslation("MC reverse mode: OFF (port ", "MC reverse mode: OFF (port ");
        _addTranslation("SmartProxy: ON (port ", "SmartProxy: ON (port ");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: OFF (port ");
        _addTranslation("Link Grabber", "Link Grabber");
        _addTranslation("Select DLC container", "Select DLC container");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "No MEGA accounts available (Go to Settings > Accounts)");
        _addTranslation("MEGA API KEY:", "MEGA API KEY:");
        _addTranslation("MEGA API KEY ERROR", "MEGA API KEY ??");
        _addTranslation("An older version of MegaBasterd has been detected (", "An older version of MegaBasterd has been detected (");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ".\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.");
        _addTranslation("All your transferences have finished", "All your transferences have finished");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "Host");
        _addTranslation("User", "User");
        _addTranslation("Password", "Password");
        _addTranslation("API-KEY", "API-KEY");
        _addTranslation("Test", "Test");
        _addTranslation("OK", "OK");
        _addTranslation("No", "No");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Restore MegaBasterd window", "Restore MegaBasterd window");
        _addTranslation("Exit from MegaBasterd", "Exit from MegaBasterd");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Used space: 0.00GB");
        _addTranslation("Open folder in browser", "Open folder in browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "CANCEL ALL DOWNLOADS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "MEGA ACCOUNTS ARE LOCKED");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORT ACCOUNTS (FILE)");
        _addTranslation("Monitor clipboard looking for new links", "Monitor clipboard looking for new links");
        _addTranslation("SURE?", "SURE?");
    }

    private void Hungarian() {
        _addTranslation("COPY ALL", "ÖSSZES MÁSOLÁSA");
        _addTranslation("ALL COPIED!", "ÖSSZES MÁSOLVA!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "AZONOS NEVŰ ÉS MÉRETŰ FÁJL MÁR LÉTEZIK");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "FIGYELEM: A MEGA API HASZNÁLATA API KULCS NÉLKÜL MEGSÉRTHETI A FELHASZNÁLÁSI FELTÉTELEKET. SZEREZNED KELLENE EGY KULCSOT -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "FIGYELEM: A MEGA API HASZNÁLATA API KULCS NÉLKÜL MEGSÉRTHETI A FELHASZNÁLÁSI FELTÉTELEKET.\n\nSZEREZNED KELLENE EGY KULCSOT -> https://mega.nz/sdk (és állítsd be a MegaBasterd HALADÓ BEÁLLÍTÁSOK menüjében).\n\nLÉTREHOZOL API KULCSOT MOST?");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "FIGYELEM: proxyk vagy VPN használata azért, hogy túlléphesd a MEGA napi korlátját megsértheti a Felhasználási feltételeket. HASZNÁLD EZT A FUNKCIÓT A SAJÁT FELELŐSSÉGEDRE.");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "FIGYELEM: proxyk vagy VPN használata azért, hogy túlléphesd a MEGA napi korlátját megsértheti a Felhasználási feltételeket.\n\nHASZNÁLD EZT A FUNKCIÓT A SAJÁT FELELŐSSÉGEDRE.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "A következő parancs végrehajtása a MEGA letöltési korlát elérésekor:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "A következő proxy lista használata (ahelyett ami a MegaBasterd-ben szerepel) A formátum: [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "Várakozás az elkészülési kezelőre ... ***NE LÉPJ KI A MEGABASTERD-BŐL MOST***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "CBC-MAC kód kiszámításának befejezése (ez eltarthat egy darabig) ... ***NE LÉPJ KI A MEGABASTERD-BŐL MOST***");
        _addTranslation("Split content in different uploads", "Tartalom szétválasztása a különböző feltöltésekben");
        _addTranslation("Merge content in the same upload", "Tartalom összeolvasztása az azonos feltöltésben");
        _addTranslation("How do you want to proceed?", "Hogyan szeretnéd folytatni?");
        _addTranslation("Put on TOP of waiting queue", "A várakozási lista TETEJÉRE helyezése");
        _addTranslation("TOP", "TETEJÉRE");
        _addTranslation("BOTTOM", "ALJÁRA");
        _addTranslation("Freeze transferences before start", "Átvitelek megfagyasztása kezdés előtt");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "VÁRAKOZÓ ÁTVITELEK KIFAGYASZTÁSA");
        _addTranslation("(FROZEN) Waiting to start...", "(FAGYOTT) Várakozás az indításra...");
        _addTranslation("(FROZEN) Waiting to start (", "(FAGYOTT) Várakozás az indításra (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Nagyon sok fájl van ebben a mappában.\nA linkek sorban kerülnek feldolgozásra, a MegaBasterd túlterhelődés elkerülése érdekében");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Túl sokszor próbáltál bejelentkezni. Várj egy órát.");
        _addTranslation("MEGA LINK ERROR!", "MEGA LINK HIBA");
        _addTranslation("Please enter 2FA PIN CODE", "Kérlek írd be a kétlépcsős azonosító kódot");
        _addTranslation("Enable log file", "Log fájl engedélyezése");
        _addTranslation("Font:", "Betűtípus:");
        _addTranslation("Loading...", "Betöltés...");
        _addTranslation("DEFAULT", "ALAPÉRTELMEZETT");
        _addTranslation("ALTERNATIVE", "ALTERNATÍV");
        _addTranslation("Download latest version", "Legfrissebb verzió letöltése");
        _addTranslation("PROVISION FAILED", "FELDOLGOZÁS SIKERTELEN");
        _addTranslation("Error registering download: file is already downloading.", "Hiba a letöltés hozzáadásában: a fájl letöltése már folyamatban van.");
        _addTranslation("FATAL ERROR! ", "VÉGZETES HIBA");
        _addTranslation("ERROR: FILE NOT FOUND", "HIBA: A FÁJL NEM TALÁLHATÓ");
        _addTranslation("Mega link is not valid! ", "A Mega link nem megfelelő!");
        _addTranslation("Checking your MEGA accounts, please wait...", "A MEGA fiókjaid ellenőrzése, kérlek várj...");
        _addTranslation("Check for updates", "Frissítés keresése");
        _addTranslation("Checking, please wait...", "Ellenőrzés, kérlek várj...");
        _addTranslation("You have the latest version ;)", "Neked már a legfrissebb verzió van ;)");
        _addTranslation("Copy MegaBasterd download URL", "MegaBasterd letöltési link másolása");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Készítette: tonikelope sok szeretettel (és garancia nélkül). Fordította: Roschach96");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Még egy nem hivatalos (és ocsmány) platformok közti MEGA letöltő/feltöltő/streamelő program");
        _addTranslation("MEGA URL was copied to clipboard!", "MEGA link a vágólapra másolva");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "MegaBasterd ÚJ VERZIÓ elérhető! ->");
        _addTranslation("Selecting folder...", "Mappa kiválasztása...");
        _addTranslation("MERGE FILE", "FÁJL ÖSSZEOLVASZTÁSA");
        _addTranslation("Delete parts after merge", "Részfájlok törlése összeolvasztás után");
        _addTranslation("Remove selected", "Kiválasztott fájl(ok) törlése");
        _addTranslation("SPLIT FILE", "FÁJL SZÉTVÁLASZTÁSA");
        _addTranslation("Encrypt on disk sensitive information", "Lemezen lévő érzékeny információ titkosítása");
        _addTranslation("Allow using MEGA accounts for download/streaming", "Letöltés/Streamelés engedélyezése a MEGA fiókok számára ");
        _addTranslation("Please wait...", "Kérlek várj...");
        _addTranslation("CANCEL RETRY", "ÚJRAPRÓBÁLKOZÁS MEGSZAKÍTÁSA");
        _addTranslation("SPLITTING FILE...", "FÁJL SZÉTVÁLASZTÁSA...");
        _addTranslation("Open folder", "Mappa megnyitása");
        _addTranslation("RESUME DOWNLOAD", "LETÖLTÉS FOLYTATÁSA");
        _addTranslation("Close", "Bezárás");
        _addTranslation("Add files", "Fájlok hozzáadása");
        _addTranslation("IMPORT SETTINGS", "BEÁLLÍTÁSOK IMPORTÁLÁSA");
        _addTranslation("RESET MEGABASTERD", "MEGABASTERD ALAPHELYZETBE ÁLLÍTÁSA");
        _addTranslation("RESET ACCOUNTS", "FIÓKOK ALAPHELYZETBE ÁLLÍTÁSA");
        _addTranslation("Verify file integrity (when download is finished)", "Fájl integritás ellenőrzése (amikor a letöltés befejeződött)");
        _addTranslation("Let's dance, baby", "Letöltés indítása");
        _addTranslation("Unlock accounts", "Fiókok feloldása");
        _addTranslation("Use MegaCrypter reverse mode", "MegaCrypter fordított mód használata");
        _addTranslation("Select (any) file part", "Válassz ki részfájlokat");
        _addTranslation("Add folder", "Mappa hozzáadása");
        _addTranslation("Adding files, please wait...", "Fájlok hozzáadása, kérlek várj...");
        _addTranslation("Restart", "Újraindítás");
        _addTranslation("Use SmartProxy", "SmartProxy használata");
        _addTranslation("PAUSE DOWNLOAD", "LETÖLTÉS SZÜNETELTETÉSE");
        _addTranslation("Change it", "Megváltoztatás");
        _addTranslation("EXPORT SETTINGS", "BEÁLLÍTÁSOK EXPORTÁLÁSA");
        _addTranslation("Change output folder", "Kimeneti mappa megváltoztatása");
        _addTranslation("Add account", "Fiók hozzáadása");
        _addTranslation("Select file", "Fájl kiválasztása");
        _addTranslation("Opening file...", "Fájl megnyitása...");
        _addTranslation("CANCEL DOWNLOAD", "LETÖLTÉS MEGSZAKÍTÁSA");
        _addTranslation("REMOVE ALL EXCEPT THIS", "A KIJELÖLTÖN KÍVÜL AZ ÖSSZES TÖRLÉSE");
        _addTranslation("Loading DLC, please wait...", "DLC betöltése, kérlek várj...");
        _addTranslation("Changing output folder...", "Kimeneti mappa megváltoztatása...");
        _addTranslation("RESUME UPLOAD", "FELTÖLTÉS FOLYTATÁSA");
        _addTranslation("Limit upload speed", "Feltöltési sebesség korlátozása");
        _addTranslation("CANCEL", "MÉGSE");
        _addTranslation("Use multi slot download mode", "Többszálas letöltési mód használata");
        _addTranslation("Selecting file...", "Fájl kiválasztása...");
        _addTranslation("Copy folder link", "Mappa link másolása");
        _addTranslation("Limit download speed", "Letöltési sebesség korlátozása");
        _addTranslation("REMOVE THIS", "TÖRLÉS");
        _addTranslation("Copy file link", "Fájl link másolása");
        _addTranslation("Load DLC container", "DLC konténer betöltése");
        _addTranslation("Adding folder, please wait...", "Mappa hozzáadása, kérlek várj...");
        _addTranslation("PAUSE UPLOAD", "FELTÖLTÉS SZÜNETELTÉSE");
        _addTranslation("CANCEL CHECK", "ELLENŐRZÉS MEGSZAKÍTÁSA");
        _addTranslation("Keep temp file", "Ideiglenes fájl megtartása");
        _addTranslation("Use HTTP(S) PROXY", "HTTP(S) PROXY használata");
        _addTranslation("MERGING FILE...", "FÁJL(OK) ÖSSZEOLVASZTÁSA");
        _addTranslation("Checking MEGA account...", "MEGA fiók ellenőrzése");
        _addTranslation("SAVE", "MENTÉS");
        _addTranslation("New download", "Új letöltés hozzáadása");
        _addTranslation("New upload", "Új feltöltés hozzáadása");
        _addTranslation("New streaming", "Új stream hozzáadása");
        _addTranslation("Split file", "Fájl szétválasztása");
        _addTranslation("Merge file", "Fájl(ok) összeolvasztása");
        _addTranslation("Remove all no running downloads", "Összes nem futó letöltés törlése");
        _addTranslation("Remove all no running uploads", "Összes nem futó feltöltés törlése");
        _addTranslation("Edit", "Beállítások");
        _addTranslation("Settings", "Beállítások");
        _addTranslation("Help", "Súgó");
        _addTranslation("About", "Névjegy");
        _addTranslation("Remember for this session", "Session megjegyzése");
        _addTranslation("Restore folder data", "Mappa adat helyreállítása");
        _addTranslation("Restoring data, please wait...", "Adat helyreállítása, kérlek várj...");
        _addTranslation("File", "Fájl");
        _addTranslation("Hide to tray", "Minimalizálás a tálcára");
        _addTranslation("Clear finished", "Befejezetettek törlése");
        _addTranslation("Exit", "Kilépés");
        _addTranslation("Default slots per file:", "Alapértelmezett szálak fájlonként:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Tipp: Ha MEGA PREMIUM fiók nélkül akarsz letölteni, AJÁNLOTT bekapcsolni. (A szálak RAM-ot használnak, úgyhogy használd saját felelősségre).");
        _addTranslation("Max speed (KB/s):", "Max sebesség (KB/s)");
        _addTranslation("Default account:", "Alapértelmezett fiók:");
        _addTranslation("TCP Port:", "TCP Port:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Tipp: MUSZÁLY \"MEGNYITNOD\" ezt a portot a routereden/tűzfaladon");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Tipp: engedélyezd azért, hogy a sebességkorlát figyelmen kaívül legyen hagyva. (Több szál szükséges).");
        _addTranslation("Max parallel downloads:", "Max párhuzamos letöltés:");
        _addTranslation("Max parallel uploads:", "Max párhuzamos feltöltés:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Tipp: A szálak RAM-ot használnak, úgyhogy használd saját felelősségre");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Tipp: Használhatsz opcionális email címeket -> bob@supermail.com#bob_mail (ne felejts menteni a fiókok beírása után).");
        _addTranslation("Your MEGA accounts:", "A MEGA fiókjaid:");
        _addTranslation("Your ELC accounts:", "Az ELC fiókjaid:");
        _addTranslation("Note: restart required.", "Tipp: újraindítás szükséges.");
        _addTranslation("Note: restart might be required.", "Tipp: újraindítás szükséges lehet.");
        _addTranslation("Font ZOOM (%):", "Betűtípus ZOOM (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Tipp: A MegaBasterd ezt a proxyt fogja használni MINDEN kapcsolathoz.");
        _addTranslation("Port:", "Port:");
        _addTranslation("Settings successfully saved!", "Beállítások sikeresen mentve!");
        _addTranslation("Settings successfully imported!", "Beállítások sikeresen importálva!");
        _addTranslation("Settings successfully exported!", "Beállítások sikeresen exportálva!");
        _addTranslation("Settings successfully reset!", "Beállítások sikeresen visszaállítva!");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Hibák voltak néhány fiókkal (az email és/vagy jelszó hibás). Kérlek ellenőrizd őket:\n\n");
        _addTranslation("Settings saved", "Beállítások mentve");
        _addTranslation("Settings imported", "Beállítások importálva");
        _addTranslation("Settings exported", "Beállítások exportálva");
        _addTranslation("Settings reset", "Beállítások visszaállítva");
        _addTranslation("MegaBasterd will restart", "A MegaBasterd most újraindul");
        _addTranslation("Restart required", "Újraindítás szükséges");
        _addTranslation("File is not readable!", "A fájl nem olvasható");
        _addTranslation("Folder is not readable!", "A mappa nem olvasható");
        _addTranslation("BAD PASSWORD!", "HELYTELEN JELSZÓ");
        _addTranslation("Passwords does not match!", "A jelszavak nem egyeznek!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Kérlek, másolj be egy Mega/MegaCrypter/ELC linket!");
        _addTranslation("Yes", "Igen");
        _addTranslation("Cancel", "Mégse");
        _addTranslation("UNEXPECTED ERROR!", "VÁRATLAN HIBA");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "A MegaBasterd éppen videót streamel. Ki szeretnél lépni:");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "A MegaBasterd éppen feldolgozza a fel- és letöltéseket.\n\nHa most kilépsz, a feldolgozatlan fel- és letöltések el fognak veszni.\n\nSzeretnéd folytatni?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "A MegaBasterd éppen fájlok feltöltését fejezi be.\n\nHA MOST KILÉPSZ, AZOK A FELTÖLTÉSEK ELVESZNEK\n\nSzeretnéd folytatni?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Minden jelenlegi beállításod és fiókod törölve lesz az importálás után (Ezért ajánlott a jelenlegi beállításaidat exportálni egy importálás előtt).\n\nSzeretnéd folytatni?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Csak a MENTETT beállítások és fiókok lesznek exportálva. (Ha nem vagy biztos a dolgodban, először mentsd el a jelenlegi beállításaidat és aztán használni az exportálást).\n\nSzeretnéd folytatni?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "A Mester jelszó vissza lesz állítva és minden fiókod törölve lesz. (EZT NEM LEHET VISSZAVONNI)\n\nSzeretnéd folytatni?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "MINDEN BEÁLLÍTÁS, FIÓK ÉS ÁTVITEL TÖRÖLÉVE LESZ. (EZT NEM LEHET VISSZAVONNI)\n\nSzeretnéd folytatni?");
        _addTranslation("Remove all no running downloads?", "Összes nem futó letöltés törlése");
        _addTranslation("Warning!", "Figyelem!");
        _addTranslation("Remove all no running uploads?", "Összes nem futó feltöltés törlése");
        _addTranslation("Please, enter your master password", "Kérlek írd be a Mester jelszavad");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "FIGYELEM: Ha elfelejted ezt a jelszót, minden fiókot újra be kell írnod.");
        _addTranslation("New pass:", "Új jelszó:");
        _addTranslation("Confirm new:", "Új jelszó megerősítése:");
        _addTranslation("Verifying your password, please wait...", "Új jelszó ellenőrzése, kérlek várj...");
        _addTranslation("Processing your password, please wait...", "Új jelszó feldolgozása, kérlek várj...");
        _addTranslation("Downloads", "Letöltések");
        _addTranslation("Uploads", "Feltöltések");
        _addTranslation("Accounts", "Fiókok");
        _addTranslation("Advanced", "Haladó");
        _addTranslation("Language:", "Nyelv");
        _addTranslation("English", "Angol");
        _addTranslation("Spanish", "Spanyol");
        _addTranslation("Loading files, please wait...", "Fájlok betöltése, kérlek várj...");
        _addTranslation("Checking account quota, please wait...", "Fiók kvóta ellenőrzése, kérlek várj...");
        _addTranslation("ERROR checking account quota!", "HIBA a fiók kvóta ellenőrzésében!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Ha NEM akarsz egyes mappát vagy fájlt áttranszferelni, TÖRÖLNI tudod őket (a kijelölésükhöz használd a CTRL + BKLIKK gombkombinációt).");
        _addTranslation("Upload name:", "Feltöltés neve");
        _addTranslation("Account:", "Fiók");
        _addTranslation("Folder link detected!", "Mappa link észlelve!");
        _addTranslation("File already exists!", "A fájl már létezik!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "A Megabasterd  éppen biztonságosan leállítja az átviteleket, kérlek várj...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "Másold a MEGA/MegaCrypter/ELC linkeket ide (egy darab soronként)");
        _addTranslation("Download folder:", "Letöltési mappa:");
        _addTranslation("Split size (MBs):", "Szétválasztási méret (MB)");
        _addTranslation("File successfully splitted!", "A fájl sikeresen szétválasztva!");
        _addTranslation("File successfully merged!", "A fájl sikeresen összeolvasztva!");
        _addTranslation("File successfuly downloaded!", "A fájl sikeresen letöltve!");
        _addTranslation("Download paused!", "Letöltés szüneteltetve!");
        _addTranslation("Downloading file from mega ...", "Fájl letöltése a MEGA-ról ...");
        _addTranslation("Copy link", "Link másolása");
        _addTranslation("Downloading file from mega ", "Fájl letöltése a MEGA-ról ");
        _addTranslation("EXIT NOW", "KILÉPÉS MOST");
        _addTranslation("Download CANCELED!", "Letöltés MEGSZAKÍTVA");
        _addTranslation("Upload CANCELED!", "Feltöltés MEGSZAKÍTVA");
        _addTranslation("Uploading file to mega (", "Fájl feltöltése a MEGA-ra (");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Másold a MEGA/MegaCrypter/ELC linkeket ide, hogy kapj egy stream linket");
        _addTranslation("Use this account for streaming:", "Streamingre használandó fiók:");
        _addTranslation("Use this account for download:", "Letöltésre használandó fiók:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "Stream link a vágólapra másolva!\nNe felejtsd el, hogy a MegaBasterd-nek a háttérben kell futnia a tartalom lejátszása közben");
        _addTranslation("CANCEL UPLOAD", "FELTÖLTÉS MEGSZAKÍTÁSA");
        _addTranslation("Upload paused!", "Feltöltés szüneteltetve!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "A MegaBasterd kilépés előtt biztonságosan leállítja a letöltéseket, kérlek várj...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "A MegaBasterd kilépés előtt biztonságosan leállítja a feltöltéseket, kérlek várj...");
        _addTranslation("Starting download, please wait...", "Letöltések indítása, kérlek várj...");
        _addTranslation("Starting upload, please wait...", "Feltöltések indítása, kérlek várj...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "Letöltések indítása (MEGA ideiglenes link lekérése), kérlek várj...");
        _addTranslation("File exists, resuming download...", "A fájl már létezik. letöltés folytatása...");
        _addTranslation("Truncating temp file...", "Ideiglenes fájl feldarabolása...");
        _addTranslation("Waiting to check file integrity...", "Várakozás a fájl integritás ellenőrzésre...");
        _addTranslation("Checking file integrity, please wait...", "Fájl integritás ellenőrzése, kérlek várj...");
        _addTranslation("Provisioning download, please wait...", "Letöltés ellenőrzése, kérlek várj...");
        _addTranslation("Waiting to start...", "Várakozás az indításra...");
        _addTranslation("Provisioning upload, please wait...", "Feltöltés ellenőrzése, kérlek várj...");
        _addTranslation("Waiting to start (", "Várakozás az indításra (");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Új MEGA csomópont létrehozása ... ***NE LÉPJ KI A PROGRAMBÓL***");
        _addTranslation("File successfully uploaded! (", "Fájl sikeresen feltöltve! (");
        _addTranslation("PAUSE ALL", "ÖSSZES SZÜNETELTETÉSE");
        _addTranslation("RESUME ALL", "ÖSSZES FOLYTATÁSA");
        _addTranslation("MEGA folder link was copied to clipboard!", "MEGA mappa link a vágólapra másolva!");
        _addTranslation("MEGA file link was copied to clipboard!", "MEGA fájl link a vágólapra másolva!");
        _addTranslation("Pausing download ...", "Letöltés szüneteltetése");
        _addTranslation("Pausing upload ...", "Feltöltés szüneteltetése");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "A fájl sikeresen letöltve! (Integritás ellenőrzés SIKERES)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "A fájl sikeresen letöltve! (de az integritás ellenőrzés MEGSZAKÍTVA)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "A FELTÖLTÉS megszakadt! (Üres elkészülési kezelő!)");
        _addTranslation("UPLOAD FAILED: too many errors", "FELTÖLTÉS megszakadt: Túl sok hiba");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "FELTÖLTÉS megszakadt: VÉGSŐ HIBA");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "A fájl SÉRÜLT");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "A MEGA LINK IDEIGLENESEN ELÉRHETETLEN");
        _addTranslation("File temporarily unavailable! (Retrying in ", "A fájl ideiglenesen elérhetetlen");
        _addTranslation(" secs...)", " sec...");
        _addTranslation(" (Retrying in ", " (Újrapróbálkozás ennyi idő múlva ");
        _addTranslation("Proxy settings", "Proxy beállítások");
        _addTranslation("Authentication", "Hitelesítés");
        _addTranslation("Upload info", "Feltöltési infó");
        _addTranslation("Files", "Fájlok");
        _addTranslation("Username:", "Felhasználónév");
        _addTranslation("Password:", "Jelszó");
        _addTranslation("Link was copied to clipboard!", "A link a vágólapra másolva");
        _addTranslation("Checking if there are previous downloads, please wait...", "Annak ellenőrzése. hogy van-e előző letöltés, kérlek várj...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Annak ellenőrzése. hogy van-e előző feltöltés, kérlek várj...");
        _addTranslation("Restore window", "Ablak visszaállítása");
        _addTranslation("EXIT", "KILÉPÉS");
        _addTranslation("File successfully downloaded!", "Fájl sikeresen letöltve!");
        _addTranslation("Quota used: ", "Kvóta felhasználva: ");
        _addTranslation("Streaming server: ON (port ", "Stream szerver: BEKAPCSOLVA (port ");
        _addTranslation("MC reverse mode: ON (port ", "MC fordított mód: BEKAPCSOLVA (port ");
        _addTranslation("Joining file chunks, please wait...", "Fájlrészek összeolvasztása, kérlek várj...");
        _addTranslation("Close MegaBasterd when all transfers finish", "MegaBasterd bezárása amikor minden átvitel befejeződött");
        _addTranslation("Use custom temporary directory for chunks storage", "Egyedi ideiglenes mappa használata a fájlrészek tárolására");
        _addTranslation("CANCEL ALL DOWNLOADS", "ÖSSZES LETÖLTÉS MEGSZAKÍTÁSA");
        _addTranslation("Save debug info to file", "Debug info mentése fájlba");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "A következő proxy lista használata, a formátum: [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "Szálak");
        _addTranslation("MC reverse mode: OFF (port ", "MC fordított mód: KIKAPCSOLVA (port ");
        _addTranslation("Pre:", "Előkészületben:");
        _addTranslation("Pro:", "Folyamatban:");
        _addTranslation("Wait:", "Várakozik:");
        _addTranslation("Run:", "Fut:");
        _addTranslation("Finish:", "Befejezett:");
        _addTranslation("Rem:", "Hátralévő:");
        _addTranslation("Italian", "Olasz");
        _addTranslation("Chinese", "Kínai");
        _addTranslation("German", "Német");
        _addTranslation("Hungarian", "Magyar");
        _addTranslation("Turkish", "Török");
        _addTranslation("Streaming server: OFF (port ", "Streaming server: OFF (port ");
        _addTranslation("MC reverse mode: OFF (port ", "MC reverse mode: OFF (port ");
        _addTranslation("SmartProxy: ON (port ", "SmartProxy: BEKAPCSOLVA (port ");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: KIKAPCSOLVA (port ");
        _addTranslation("Link Grabber", "Link Gyűjtő");
        _addTranslation("Select DLC container", "DLC konténer kiválasztása");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "Nem elérhető MEGA fiók (Menj a Beállítások > Fiókok menübe)");
        _addTranslation("MEGA API KEY:", "MEGA API KULCS:");
        _addTranslation("MEGA API KEY ERROR", "MEGA API KULCS HIBA");
        _addTranslation("An older version of MegaBasterd has been detected (", "A MegaBasterd egy régebbi verziója észlelhető");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ").\nSzeretnéd importálni az összes jelenlegi beállításodat és átviteledet az előző verzióból?\nFIGYELEM: ELŐFORDULHAT, HOGY EGYES VERZIÓK KÖZÖTT NINCS KOMPATIBILITÁS");
        _addTranslation("All your transferences have finished", "Minden átvitel befejeződött");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "Host");
        _addTranslation("User", "Felhasználónév");
        _addTranslation("Password", "Jelszó");
        _addTranslation("API-KEY", "API-KULCS");
        _addTranslation("Test", "Teszt");
        _addTranslation("OK", "OK");
        _addTranslation("No", "Nem");
        _addTranslation("MC reverse mode: OFF", "MC fordított mód: KIKAPCSOLVA");
        _addTranslation("Restore MegaBasterd window", "MegaBasterd ablak visszaállítása");
        _addTranslation("Exit from MegaBasterd", "Kilépés a MegaBasterd-ből");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Felhasznált tárhely: 0,00GB");
        _addTranslation("Open folder in browser", "Open folder in browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "CANCEL ALL DOWNLOADS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "MEGA ACCOUNTS ARE LOCKED");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORT ACCOUNTS (FILE)");
        _addTranslation("Monitor clipboard looking for new links", "Monitor clipboard looking for new links");
        _addTranslation("SURE?", "SURE?");
    }

    private void Vietnamese() {
        _addTranslation("COPY ALL", "SAO CHÉP TẤT CẢ");
        _addTranslation("ALL COPIED!", "ĐÃ SAO CHÉP TẤT CẢ!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "TỆP CÙNG TÊN VÀ KÍCH CỠ ĐÃ TỒN TẠI");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "CẢNH BÁO: SỬ DỤNG API MEGA MÀ KHÔNG CÓ KHOÁ API CÓ THỂ VI PHẠM ĐIỀU KHOẢN SỬ DỤNG. HÃY TẠO KHOÁ -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "CẢNH BÁO: SỬ DỤNG API MEGA MÀ KHÔNG CÓ KHOÁ API CÓ THỂ VI PHẠM ĐIỀU KHOẢN SỬ DỤNG.\n\nHÃY TẠO KHOÁ -> https://mega.nz/sdk (và đặt nó trong phần CÀI ĐẶT NÂNG CAO của MegaBasterd)");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "CẢNH BÁO: Sử dụng proxy hoặc VPN để vượt giới hạn tải hàng ngày của MEGA có thể vi phạm Điều khoản Sử dụng. BẠN SẼ TỰ CHỊU RỦI RO KHI SỬ DỤNG TÍNH NĂNG NÀY.");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "CẢNH BÁO: Sử dụng proxy hoặc VPN để vượt giới hạn tải hàng ngày của MEGA có thể vi phạm Điều khoản Sử dụng.\n\nBẠN SẼ TỰ CHỊU RỦI RO KHI SỬ DỤNG TÍNH NĂNG NÀY.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "Thực hiện câu lệnh này khi đạt đến giới hạn tải xuống của MEGA:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "Sử dụng danh sách proxy này (thay vì cái đã có trong MegaBasterd) Định dạng là [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "Đang chờ trình xử lý hoàn thành ... ***KHÔNG THOÁT MEGABASTERD BÂY GIỜ***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "Đang hoàn thành tính toán mã CBC-MAC (điều này có thể lâu 1 chút) ... ***KHÔNG THOÁT MEGABASTERD BÂY GIỜ***");
        _addTranslation("Split content in different uploads", "Tách nội dung trong các lần tải lên khác nhau");
        _addTranslation("Merge content in the same upload", "Nối nội dung trong cùng lần tải lên");
        _addTranslation("How do you want to proceed?", "Bạn muốn tiếp tục như thế nào?");
        _addTranslation("Put on TOP of waiting queue", "Đặt lên ĐẦU hàng chờ");
        _addTranslation("TOP", "ĐẦU");
        _addTranslation("BOTTOM", "CUỐI");
        _addTranslation("Freeze transferences before start", "Cố định các chuyển đổi trước khi bắt đầu");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "HUỶ CỐ ĐỊNH CÁC CHUYỂN ĐỔI ĐANG CHỜ");
        _addTranslation("(FROZEN) Waiting to start...", "(ĐÃ CỐ ĐỊNH) Đang đợi bắt đầu...");
        _addTranslation("(FROZEN) Waiting to start (", "(ĐÃ CỐ ĐỊNH) Đang đợi bắt đầu (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Có rất nhiều tệp trong thư mục này.\nKhông phải tất cả các liên kết sẽ được giám sát cấp phép cùng lúc để tránh bão hoà MegaBasterd");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Bạn đã cố gắng đăng nhập quá nhiều lần. Hãy đợi trong 1 giờ.");
        _addTranslation("MEGA LINK ERROR!", "LỖI LIÊN KẾT MEGA!");
        _addTranslation("Please enter 2FA PIN CODE", "Hãy nhập MÃ PIN 2FA");
        _addTranslation("Enable log file", "Bật tệp nhật ký");
        _addTranslation("Font:", "Phông chữ:");
        _addTranslation("Loading...", "Đang tải...");
        _addTranslation("DEFAULT", "MẶC ĐỊNH");
        _addTranslation("ALTERNATIVE", "THAY THẾ");
        _addTranslation("Download latest version", "Tải xuống phiên bản mới nhất");
        _addTranslation("PROVISION FAILED", "CẤP QUYỀN THẤT BẠI");
        _addTranslation("Error registering download: file is already downloading.", "Lỗi khi đăng ký tải xuống: tệp dang được tải xuống.");
        _addTranslation("FATAL ERROR! ", "LỖI NGHIÊM TRỌNG!");
        _addTranslation("ERROR: FILE NOT FOUND", "LỖI: KHÔNG TÌM THẤY TỆP");
        _addTranslation("Mega link is not valid! ", "Liên kết Mega không hợp lệ!");
        _addTranslation("Checking your MEGA accounts, please wait...", "Đang kiểm tra tài khoản MEGA, xin đợi chút...");
        _addTranslation("Check for updates", "Kiểm tra cập nhật");
        _addTranslation("Checking, please wait...", "Đang kiếm tra, xin đợi chút...");
        _addTranslation("You have the latest version ;)", "Bạn đang sử dụng phiên bản mới nhất ;)");
        _addTranslation("Copy MegaBasterd download URL", "Sao chép URL tải xuống MegaBasterd");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Được tạo ra với tình yêu (và không có đảm bảo) bởi tonikelope.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Lại là một công cụ tải xuống/tải lên/phát trực tuyến MEGA đa nền tảng không chính thức (và xấu xí) khác.");
        _addTranslation("MEGA URL was copied to clipboard!", "URL MEGA đã được sao chép vào khay nhớ tạm!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "PHIÊN BẢN MỚI của MegaBasterd đang khả dụng! ->");
        _addTranslation("Selecting folder...", "Đang chọn thư mục...");
        _addTranslation("MERGE FILE", "NỐI TỆP");
        _addTranslation("Delete parts after merge", "Xoá các phần sau khi nối");
        _addTranslation("Remove selected", "Huỷ chọn");
        _addTranslation("SPLIT FILE", "TÁCH TỆP");
        _addTranslation("Encrypt on disk sensitive information", "Mã hoá trên đĩa các thông tin nhạy cảm");
        _addTranslation("Allow using MEGA accounts for download/streaming", "Chấp nhận sử dụng các tài khoản MEGA cho tải xuống/phát trực tuyến");
        _addTranslation("Please wait...", "Xin đợi chút...");
        _addTranslation("CANCEL RETRY", "HUỶ THỬ LẠI");
        _addTranslation("SPLITTING FILE...", "ĐANG TÁCH TỆP...");
        _addTranslation("Open folder", "Mở thư mục");
        _addTranslation("RESUME DOWNLOAD", "TIẾP TỤC TẢI XUỐNG");
        _addTranslation("Close", "Đóng");
        _addTranslation("Add files", "Thêm tệp");
        _addTranslation("IMPORT SETTINGS", "NHẬP CÁC CÀI ĐẶT");
        _addTranslation("RESET MEGABASTERD", "ĐẶT LẠI MEGABASTERD");
        _addTranslation("RESET ACCOUNTS", "ĐẶT LẠI TÀI KHOẢN");
        _addTranslation("Verify file integrity (when download is finished)", "Xác minh sự toàn vẹn của tệp (khi hoàn thành tải xuống)");
        _addTranslation("Let's dance, baby", "Cùng nhảy nào, cưng");
        _addTranslation("Unlock accounts", "Mở khoá tài khoản");
        _addTranslation("Use MegaCrypter reverse mode", "Sử dụng chế độ đảo ngược của MegaCrypter");
        _addTranslation("Select (any) file part", "Lựa chọn (bất kỳ) phần của tệp");
        _addTranslation("Add folder", "Thêm thư mục");
        _addTranslation("Adding files, please wait...", "Đang thêm tệp, xin đợi chút...");
        _addTranslation("Restart", "Khởi động lại");
        _addTranslation("Use SmartProxy", "Sử dụng SmartProxy");
        _addTranslation("PAUSE DOWNLOAD", "TẠM NGƯNG TẢI XUỐNG");
        _addTranslation("Change it", "Thay đổi nó");
        _addTranslation("EXPORT SETTINGS", "XUẤT CÁC CÀI ĐẶT");
        _addTranslation("Change output folder", "Thay đổi thư mục đầu ra");
        _addTranslation("Add account", "Thêm tài khoản");
        _addTranslation("Select file", "Chọn tệp");
        _addTranslation("Opening file...", "Đang mở tệp...");
        _addTranslation("CANCEL DOWNLOAD", "HUỶ TẢI XUỐNG");
        _addTranslation("REMOVE ALL EXCEPT THIS", "LOẠI BỎ TẤT CẢ NGOẠI TRỪ CÁI NÀY");
        _addTranslation("Loading DLC, please wait...", "Đang tải DLC, xin đợi chút...");
        _addTranslation("Changing output folder...", "Đang thay đổi thư mục đầu ra...");
        _addTranslation("RESUME UPLOAD", "TIẾP TỤC TẢI LÊN");
        _addTranslation("Limit upload speed", "Giới hạn tốc độ tải lên");
        _addTranslation("CANCEL", "HUỶ");
        _addTranslation("Use multi slot download mode", "Sử dụng chế độ tải xuống đa chỗ");
        _addTranslation("Selecting file...", "Đang chọn tệp...");
        _addTranslation("Copy folder link", "Sao chép liên kết thư mục");
        _addTranslation("Limit download speed", "Giới hạn tốc độ tải xuống");
        _addTranslation("REMOVE THIS", "LOẠI BỎ CÁI NÀY");
        _addTranslation("Copy file link", "Sao chép liên kết tệp");
        _addTranslation("Load DLC container", "Tải vùng chứa DLC");
        _addTranslation("Adding folder, please wait...", "Đang thêm thư mục, xin đợi chút...");
        _addTranslation("PAUSE UPLOAD", "TẠM NGỪNG TẢI LÊN");
        _addTranslation("CANCEL CHECK", "HUỶ KIỂM TRA");
        _addTranslation("Keep temp file", "Giữ lại các tệp tạm thời");
        _addTranslation("Use HTTP(S) PROXY", "Sử dụng PROXY HTTP(S)");
        _addTranslation("MERGING FILE...", "ĐANG NỐI TỆP...");
        _addTranslation("Checking MEGA account...", "Kiểm tra tài khoản MEGA...");
        _addTranslation("SAVE", "LƯU");
        _addTranslation("New download", "Lượt tải xuống mới");
        _addTranslation("New upload", "Lượt tải lên mới");
        _addTranslation("New streaming", "Lượt phát trực tuyến mới");
        _addTranslation("Split file", "Tách tệp");
        _addTranslation("Merge file", "Nối tệp");
        _addTranslation("Remove all no running downloads", "Loại bỏ tất cả các tệp tải xuống đang không chạy");
        _addTranslation("Remove all no running uploads", "Loại bỏ tất cả các tệp tải lên đang không chạy");
        _addTranslation("Edit", "Chỉnh sửa");
        _addTranslation("Settings", "Cài đặt");
        _addTranslation("Help", "Trợ giúp");
        _addTranslation("About", "Về");
        _addTranslation("Remember for this session", "Ghi nhớ cho phiên này");
        _addTranslation("Restore folder data", "Khôi phục dữ liệu thư mục");
        _addTranslation("Restoring data, please wait...", "Đang khôi phục dữ liệu, xin đợi chút...");
        _addTranslation("File", "Tệp");
        _addTranslation("Hide to tray", "Ẩn xuống khay");
        _addTranslation("Clear finished", "Xoá các tệp đã hoàn thành");
        _addTranslation("Exit", "Thoát");
        _addTranslation("Default slots per file:", "Các chỗ mặc định cho mỗi tệp:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Ghi chú: nếu bạn muốn tải xuống mà không dùng tải khoản MEGA PREMIUM bạn NÊN bật nó. (Các slot tiêu thụ RAM, nên hãy sử dụng nó vừa phải).");
        _addTranslation("Max speed (KB/s):", "Tốc độ tối đa (KB/s):");
        _addTranslation("Default account:", "Tài khoản mặc định");
        _addTranslation("TCP Port:", "Cổng TC:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Note: you MUST \"OPEN\" this port in your router/firewall.");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Ghi chú: bất nó để làm giảm thiểu giới hạn băng thông. (Yêu cầu đa slot).");
        _addTranslation("Max parallel downloads:", "Tải xuống song song tối đa:");
        _addTranslation("Max parallel uploads:", "Tải lên song song tối đa:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Ghi chú: slot tiêu thụ RAM, vì vậy hãy sử dụng chúng vừa phải.");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Ghi chú: bạn có thể sử dụng (không bắt buộc) bí danh cho địa chỉ thư điện tử của bạn -> bob@supermail.com#bob_mail (đừng quên lưu sau khi nhập tài khoản của bạn).");
        _addTranslation("Your MEGA accounts:", "Tài khoản MEGA của bạn:");
        _addTranslation("Your ELC accounts:", "Tài khoản ELC của bạn:");
        _addTranslation("Note: restart required.", "Ghi chú: yêu cầu khởi động lại");
        _addTranslation("Note: restart might be required.", "Ghi chú: Khởi động lại có thể được yêu cầu");
        _addTranslation("Font ZOOM (%):", "THU PHÓNG phông chữ (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Ghi chú: MegaBasterd sẽ sử dụng proxy này cho MỌI kết nối.");
        _addTranslation("Port:", "Cổng:");
        _addTranslation("Settings successfully saved!", "Các cài đặt đã được lưu thành công!");
        _addTranslation("Settings successfully imported!", "Các cài đặt đã được nhập thành công!");
        _addTranslation("Settings successfully exported!", "Các cài đặt đã được xuất thành công!");
        _addTranslation("Settings successfully reset!", "Các cài đặt đã được đặt lại thành công!");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Có lỗi với một vài tài khoản (thư điện tử và/hoặc mật khẩu sai). Hãy kiếm tra lạiL\n\n");
        _addTranslation("Settings saved", "Các cài đặt đã được lưu");
        _addTranslation("Settings imported", "Đã nhập các cài đặt");
        _addTranslation("Settings exported", "Đã xuất các cài đặt");
        _addTranslation("Settings reset", "Các đặt lại các cài đặt");
        _addTranslation("MegaBasterd will restart", "MegaBasterd sẽ khởi động lại");
        _addTranslation("Restart required", "Yêu cầu khởi động lại");
        _addTranslation("File is not readable!", "Tệp không đọc được!");
        _addTranslation("Folder is not readable!", "Thư mục không đọc được!");
        _addTranslation("BAD PASSWORD!", "MẬT KHẨU TỒI!");
        _addTranslation("Passwords does not match!", "Mật khẩu không khớp!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Xin hãy dán liên kết Mega/MegaCrypter/ELC!");
        _addTranslation("Yes", "Có");
        _addTranslation("Cancel", "Huỷ");
        _addTranslation("UNEXPECTED ERROR!", "LỖI KHÔNG MONG ĐỢI!");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "Có vẻ như MegaBasterd đang phát trực tuyến video. Bạn có muốn thoát không?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "Có vẻ như MegaBasterd đang cung cấp các tệp tải lên/xuống.\n\nNếu bạn thoát bây giờ, các tệp tải lên/xuống không được cung cấp sẽ mất.\n\nBạn có muốn tiếp tục không?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "Có vẻ như MegaBasterd đang hoàn thành tải lên một số tệp.\n\nNẾU BẠN THOÁT BÂY GIỜ, CÁC TỆP TẢI LÊN SẼ THẤT BẠI.\n\nBạn có muốn tiếp tục không?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Tất cả các cài đặt hiện tại và tài khoản của bạn sẽ bị xoá sau khi nhập. (Khuyến khích nên xuất các cài đặt hiện tại trước khi nhập). \n\nBạn có muốn tiếp tục không?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Chỉ có các cài đặt và tài khoản ĐÃ LƯU sẽ được xuất. (Nếu bạn không chắc, tốt hơn nên lưu các cài đặt hiện tại rồi sau đó xuất chúng).\n\nBạn có muốn tiếp tục không?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "Nật khẩu cấp cao sẽ được đặt lại và tất cả tài khoản của bạn sẽ bị loại bỉ. (KHÔNG THỂ HOÀN TÁC ĐIỀU NÀY)\n\nBạn có muốn tiếp tục không?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "TẤT CẢ CÀI ĐẶT, TÀI KHOẢN VÀ SỰ CHUYỂN NHƯỢNG SẼ BỊ LOẠI BỎ. (KHÔNG THỂ HOÀN TÁC ĐIỀU NÀY)\n\nBạn có muốn tiếp tục không?");
        _addTranslation("Remove all no running downloads?", "Loại bỏ tất cả các tệp tải xuống đang không chạy?");
        _addTranslation("Warning!", "Cảnh báo!");
        _addTranslation("Remove all no running uploads?", "Loại bỏ tất cả tệp tải lên đang không chạy?");
        _addTranslation("Please, enter your master password", "Vui lòng nhập mật khẩu cấp cao");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "CẢNH BÁO: nếu bạn quên mật khẩu, bạn sẽ phải nhập lại tất cả tài khoản của bạn.");
        _addTranslation("New pass:", "Mật khẩu mới:");
        _addTranslation("Confirm new:", "Xác nhận mật khẩu mới:");
        _addTranslation("Verifying your password, please wait...", "Đang xác minh mật khẩu của bạn, xin đợi chút...");
        _addTranslation("Processing your password, please wait...", "ĐAng xử lí mật khẩu của bạn, xin đợi chút...");
        _addTranslation("Downloads", "Tải xuống");
        _addTranslation("Uploads", "Tải lên");
        _addTranslation("Accounts", "Tài khoản");
        _addTranslation("Advanced", "Nâng cao");
        _addTranslation("Language:", "Ngôn ngữ:");
        _addTranslation("English", "Tiếng Anh");
        _addTranslation("Spanish", "Tiếng Tây Ban Nha");
        _addTranslation("Loading files, please wait...", "Đang tải tệp, xin đợi chút...");
        _addTranslation("Checking account quota, please wait...", "Đang kiểm tra hạn ngạch tài khoản, xin đợi chút...");
        _addTranslation("ERROR checking account quota!", "LỖI khi kiểm tra hạn ngạch tài khoản!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Nếu bạn KHÔNG muốn chuyển một vài thư mục hoặc tệp bạn có thể LOẠI BỎ nó (để chọn vài mục cùng lúc hãy nhấn CTRL + CHUỘT TRÁI).");
        _addTranslation("Upload name:", "Tên tải lên:");
        _addTranslation("Account:", "Tài khoản:");
        _addTranslation("Folder link detected!", "Đã phát hiện liên kết thư mục!");
        _addTranslation("File already exists!", "Tệp đã tồn tại!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "MegaBasterd đang dừng các chuyển giao một cách an toàn, xin đợi chút...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "Đặt liên kết MEGA/MegaCrypter/ELC ở đây (mỗi liên kết một dòng):");
        _addTranslation("Download folder:", "Thư mục tải xuống:");
        _addTranslation("Split size (MBs):", "Tách kích cỡ (MBs):");
        _addTranslation("File successfully splitted!", "Tệp đã được tách thành công!");
        _addTranslation("File successfully merged!", "Tệp đã được nối thành công!");
        _addTranslation("File successfuly downloaded!", "Tệp đã được tải xuống thành công!");
        _addTranslation("Download paused!", "Đã ngừng tải xuống!");
        _addTranslation("Downloading file from mega ...", "Đang tải xuống tệp từ mega ...");
        _addTranslation("Copy link", "Sao chép liên kết");
        _addTranslation("Downloading file from mega ", "Đang tải xuống tệp từ mega");
        _addTranslation("EXIT NOW", "THOÁT NGAY BÂY GIỜ");
        _addTranslation("Download CANCELED!", "ĐÃ HUỶ tải xuống!");
        _addTranslation("Upload CANCELED!", "ĐÃ HUỶ tải lên!");
        _addTranslation("Uploading file to mega (", "Đang tải tệp lên mega (");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Đặt liên kết MEGA/MegaCrypter/ELC ở đây để nhận liên kết trực tuyến:");
        _addTranslation("Use this account for streaming:", "Sử dụng tài khoản cho phát trực tuyến:");
        _addTranslation("Use this account for download:", "Sử dụng tài khoản cho việc tải xuống:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "Liên kết phát trực tiếp đã được sao chép vào khay nhớ tạm!\nHãy nhớ giữ MegaBastard chạy ngầm trong khi đang chơi nội dung.");
        _addTranslation("CANCEL UPLOAD", "HUỶ TẢI LÊN");
        _addTranslation("Upload paused!", "Đã ngưng tải lên!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "Đã dừng tải xuống một cách an toàn trước khi thoát MegaMasterd, xin đợi chút...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "Đã dừng tải lên một cách an toàn trước khi thoát MegaMasterd, xin đợi chút...");
        _addTranslation("Starting download, please wait...", "Đang bắt đầu tải xuống, xin đợi chút...");
        _addTranslation("Starting upload, please wait...", "Đang bắt đầu tỉa lên, xin đợi chút...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "Đang bắt đầu tải xuống (đang lấy lại liên kết MEGA tạm thời), xin đợi chút...");
        _addTranslation("File exists, resuming download...", "Tệp đã tồn tại, tiếp tục tải xuống...");
        _addTranslation("Truncating temp file...", "Đang cắt tệp tạm thời...");
        _addTranslation("Waiting to check file integrity...", "Đang đợi để kiếm tra sự toàn vẹn của tệp...");
        _addTranslation("Checking file integrity, please wait...", "Đang kiếm tra sự toàn vẹn của tệp, xin đợi chút...");
        _addTranslation("Provisioning download, please wait...", "Đang cung cấp tải xuống, xin đợi chút...");
        _addTranslation("Waiting to start...", "Đang đợi để bắt đầu...");
        _addTranslation("Provisioning upload, please wait...", "Đang cung cấp tải lên, xin đợi chút...");
        _addTranslation("Waiting to start (", "Đang đợi để bắt đầu (");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Đang tạo nút MEGA mới ... ***KHÔNG THOÁT MEGABASTERD BÂY GIỜ***");
        _addTranslation("File successfully uploaded! (", "Tệp đã tải lên thành công! (");
        _addTranslation("PAUSE ALL", "TẠM NGƯNG TẤT CẢ");
        _addTranslation("RESUME ALL", "TIẾP TỤC TẤT CẢ");
        _addTranslation("MEGA folder link was copied to clipboard!", "Liên kết thư mục MEGA đã được sao chép vào khay nhớ tạm!");
        _addTranslation("MEGA file link was copied to clipboard!", "Liên kết tệp MEGA đã được sao chép vào khay nhớ tạm!");
        _addTranslation("Pausing download ...", "Đang tạm ngưng tải xuống ...");
        _addTranslation("Pausing upload ...", "Đang tạm ngưng tải lên ...");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "Tệp đã tải xuống thành công! (ĐÃ VƯỢT QUA kiểm tra toàn vẹn)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "Tệp đã tải xuống thành công! (nhưng kiểm tra toàn vẹn THẤT BẠI)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "TẢI LÊN THẤT BẠI! (Trình xử lý hoàn thành trống!)");
        _addTranslation("UPLOAD FAILED: too many errors", "TẢI LÊN THẤT BẠI: quá nhiều lỗi");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "TẢI LÊN THẤT BẠI: LỖI NGHIÊM TRỌNG");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "TIN BUỒN :( Tệp đã hỏng!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "LIÊN KẾT MEGA TẠM THỜI KHÔNG KHẢ DỤNG!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "Tệp tạm thời không khả dụng! (Thử lại sau");
        _addTranslation(" secs...)", "  giây...)");
        _addTranslation(" (Retrying in ", " (Thử lại sau");
        _addTranslation("Proxy settings", "Cài đặt proxy");
        _addTranslation("Authentication", "Xác thực");
        _addTranslation("Upload info", "Thông tin tải lên");
        _addTranslation("Files", "Tệp");
        _addTranslation("Username:", "Tên người dùng:");
        _addTranslation("Password:", "Mật khẩu");
        _addTranslation("Link was copied to clipboard!", "Liên kết được được sao chép vào khay nhớ tạm!");
        _addTranslation("Checking if there are previous downloads, please wait...", "Đang kiểm tra nếu có tải xuống trước đó không, xin đợi chút...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Đang kiểm tra nếu có tải lên trước đó không, xin đợi chút...");
        _addTranslation("Restore window", "Khôi phục cửa sổ");
        _addTranslation("EXIT", "THOÁT");
        _addTranslation("File successfully downloaded!", "Tệp đã tải xuống thành công!");
        _addTranslation("Quota used: ", "Hạn ngạch đã sử dụng:");
        _addTranslation("Streaming server: ON (port ", "Máy chủ phát trực tuyến: BẬT (cổng");
        _addTranslation("MC reverse mode: ON (port ", "Chế độ đảo ngược MC: BẤT (cổng");
        _addTranslation("Joining file chunks, please wait...", "Đang nối tập tin, xin đợi chút...");
        _addTranslation("Close MegaBasterd when all transfers finish", "Đóng MegaBasterd khi tất cả chuyển giao kết thúc");
        _addTranslation("Use custom temporary directory for chunks storage", "Sử dụng đường dẫn tạm thời tuỳ chỉnh cho lưu trữ khối");
        _addTranslation("CANCEL ALL DOWNLOADS", "CANCEL ALL DOWNLOADS");
        _addTranslation("Save debug info to file", "Save debug info to file");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "Slots");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Pre:", "Pre:");
        _addTranslation("Pro:", "Pro:");
        _addTranslation("Wait:", "Wait:");
        _addTranslation("Run:", "Run:");
        _addTranslation("Finish:", "Finish:");
        _addTranslation("Rem:", "Rem:");
        _addTranslation("Italian", "Italian");
        _addTranslation("Chinese", "Chinese");
        _addTranslation("German", "German");
        _addTranslation("Hungarian", "Hungarian");
        _addTranslation("Turkish", "Turkish");
        _addTranslation("Streaming server: OFF (port ", "Streaming server: OFF (port ");
        _addTranslation("MC reverse mode: OFF (port ", "MC reverse mode: OFF (port ");
        _addTranslation("SmartProxy: ON (port ", "SmartProxy: ON (port ");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: OFF (port ");
        _addTranslation("Link Grabber", "Link Grabber");
        _addTranslation("Select DLC container", "Select DLC container");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "No MEGA accounts available (Go to Settings > Accounts)");
        _addTranslation("MEGA API KEY:", "MEGA API KEY:");
        _addTranslation("MEGA API KEY ERROR", "MEGA API KEY ??");
        _addTranslation("An older version of MegaBasterd has been detected (", "An older version of MegaBasterd has been detected (");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ".\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.");
        _addTranslation("All your transferences have finished", "All your transferences have finished");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "Host");
        _addTranslation("User", "User");
        _addTranslation("Password", "Password");
        _addTranslation("API-KEY", "API-KEY");
        _addTranslation("Test", "Test");
        _addTranslation("OK", "OK");
        _addTranslation("No", "No");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Restore MegaBasterd window", "Restore MegaBasterd window");
        _addTranslation("Exit from MegaBasterd", "Exit from MegaBasterd");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Used space: 0.00GB");
        _addTranslation("Open folder in browser", "Open folder in browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "CANCEL ALL DOWNLOADS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "MEGA ACCOUNTS ARE LOCKED");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORT ACCOUNTS (FILE)");
        _addTranslation("Monitor clipboard looking for new links", "Monitor clipboard looking for new links");
        _addTranslation("SURE?", "SURE?");
    }

    private void Italian() {
        _addTranslation("COPY ALL", "Copia tutto");
        _addTranslation("ALL COPIED!", "Copia completata!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "Esiste già un file con lo stesso nome e dimensione");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "Attenzione: l'uso di API MEGA senza chiave API potrebbe violare i termini d'uso di MEGA.\nRicheidi una chiave API - > https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "Attenzione: l'usi di API Mega senza chiave API potrebbe violare i termini d'uso di Mega.\n\nRichiedi una chiave API - > https://mega.nz/sdk (e impostarla in MegaBasterd - Impostazioni avanzate).\n\nVuoi creare ora una chiave API?");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "Attenzione: l'uso di proxy o VPN per aggirare la limitazione del download giornaliero di MEGA potrebbe violare i termini d'uso di MEGA.\n\nUsa questa opzione a tuo rischio.");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "L'uso di proxy o VPN per aggirare la limitazione del download giornaliero di MEGA potrebbe violare i termini d'uso di MEGA.\n\nUsa questa opzione a tuo rischio.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "Esegui questo comando quando viene raggiunto il limite download MEGA:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "Usa questo elenco proxy (invece di quello incluso in MegaBasterd).\nIl formato è [*]IP:PORTA[@user_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "In attesa completamento gestore... *** Non uscire da MegaBasterd!!! ***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "Completamento calcolo codice CBC-MAC (questo potrebbe richiedere un po')... *** Non uscire da MegaBasterd  ora!!! ***");
        _addTranslation("Split content in different uploads", "Dividi il contenuto in diversi upload");
        _addTranslation("Merge content in the same upload", "Unisci contenuti nello stesso upload");
        _addTranslation("How do you want to proceed?", "Come vuoi procedere?");
        _addTranslation("Put on TOP of waiting queue", "Sposta in alto nella coda di attesa");
        _addTranslation("TOP", "Sposta in alto");
        _addTranslation("BOTTOM", "Sposta in basso");
        _addTranslation("Freeze transferences before start", "Blocca i trasferimenti prima dell'avvio");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "Sblocca trasferimenti in attesa");
        _addTranslation("(FROZEN) Waiting to start...", "(Bloccato) in attesa dell'avvio...");
        _addTranslation("(FROZEN) Waiting to start (", "Bloccato) in attesa dell'avvio (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Ci sono molti file in questa cartella.\nPer evitare di saturare MegaBasterd non tutti i collegamenti saranno gestiti in una sola volta.");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Hai provato ad accedere troppe volte.\nAspetta un'ora.");
        _addTranslation("MEGA LINK ERROR!", "Errore collegamento MEGA!");
        _addTranslation("Please enter 2FA PIN CODE", "Inserisci il codice pin 2FA");
        _addTranslation("Enable log file", "Abilita file registro");
        _addTranslation("Font:", "Font:");
        _addTranslation("Loading...", "Caricamento...");
        _addTranslation("DEFAULT", "Predefinita");
        _addTranslation("ALTERNATIVE", "Alternativa");
        _addTranslation("Download latest version", "Download versione più recente");
        _addTranslation("PROVISION FAILED", "Provisioning fallito");
        _addTranslation("Error registering download: file is already downloading.", "Errore durante la registrazione del download: il file è già in download.");
        _addTranslation("FATAL ERROR! ", "Errore fatale:");
        _addTranslation("ERROR: FILE NOT FOUND", "Errore: file non trovato");
        _addTranslation("Mega link is not valid! ", "Collegamento Mega non valido");
        _addTranslation("Checking your MEGA accounts, please wait...", "Verifica account Mega...");
        _addTranslation("Check for updates", "Controllo aggiornamenti");
        _addTranslation("Checking, please wait...", "Verifica...");
        _addTranslation("You have the latest version ;)", "La versione installata è aggiornata :)");
        _addTranslation("Copy MegaBasterd download URL", "Copia URL download MegaBasterd");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Realizzato con amore (e senza garanzie) da tonikelope.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Ancora un'altra suite multi piattaforma non ufficiale di download/upload/streaming per MEGA.");
        _addTranslation("MEGA URL was copied to clipboard!", "URL MEGA copiata negli Appunti!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "Disponibile nuova versione MegaBasterd! ->");
        _addTranslation("Selecting folder...", "Seleziona cartella...");
        _addTranslation("MERGE FILE", "UNISCI FILE");
        _addTranslation("Delete parts after merge", "Elimina parti dopo l'unione");
        _addTranslation("Remove selected", "Rimuovi selezionati");
        _addTranslation("SPLIT FILE/s", "Dividi file");
        _addTranslation("Encrypt on disk sensitive information", "Crittografa su disco le informazioni sensibili");
        _addTranslation("Allow using MEGA accounts for download/streaming", "Consenti uso account MEGA per download/streaming");
        _addTranslation("Please wait...", "Attendi...");
        _addTranslation("CANCEL RETRY", "Annulla ritentativo");
        _addTranslation("SPLITTING FILE...", "Divisione file...");
        _addTranslation("Open folder", "Apri cartella");
        _addTranslation("RESUME DOWNLOAD", "Riprendi download");
        _addTranslation("Close", "Chiudi");
        _addTranslation("Add files", "Aggiungi file");
        _addTranslation("IMPORT SETTINGS", "Importa impostazioni");
        _addTranslation("RESET MEGABASTERD", "Ripristina impostazioni");
        _addTranslation("RESET ACCOUNTS", "Ripristina account");
        _addTranslation("Verify file integrity (when download is finished)", "Verifica integrità file (a download completato)");
        _addTranslation("Let's dance, baby", "Conferma download");
        _addTranslation("Unlock accounts", "Sblocca account");
        _addTranslation("Use MegaCrypter reverse mode", "Usa modalità inversa MegaCrypter");
        _addTranslation("Select (any) file part", "Seleziona (qualsiasi) parte di file");
        _addTranslation("Add folder", "Aggiungi cartella");
        _addTranslation("Adding files, please wait...", "Aggiunta file");
        _addTranslation("Restart", "Riavvia");
        _addTranslation("Use SmartProxy", "Usa SmartProxy");
        _addTranslation("PAUSE DOWNLOAD", "Pausa download");
        _addTranslation("Change it", "Imposta cartella");
        _addTranslation("EXPORT SETTINGS", "Esporta impostazioni");
        _addTranslation("Change output folder", "Imposta cartella destinazione");
        _addTranslation("Add account", "Aggiungi account");
        _addTranslation("Select file/s", "Seleziona file");
        _addTranslation("Opening file...", "Apertura file..");
        _addTranslation("CANCEL DOWNLOAD", "Annulla download");
        _addTranslation("REMOVE ALL EXCEPT THIS", "Rimuovi tutto eccetto questo");
        _addTranslation("Loading DLC, please wait...", "Caricamento DLC...");
        _addTranslation("Changing output folder...", "Modifica cartella destinazione...");
        _addTranslation("RESUME UPLOAD", "Riprendi upload");
        _addTranslation("Limit upload speed", "Limita velocità upload");
        _addTranslation("CANCEL", "Annulla");
        _addTranslation("Use multi slot download mode", "Usa modo download multi slot");
        _addTranslation("Selecting file...", "Sezione file...");
        _addTranslation("Copy folder link", "Copia collegamento cartella");
        _addTranslation("Limit download speed", "Limite velocità download");
        _addTranslation("REMOVE THIS", "Rimuovi questo");
        _addTranslation("Copy file link", "Copia collegamento file");
        _addTranslation("Load DLC container", "Carica file DLC");
        _addTranslation("Adding folder, please wait...", "Aggiunta cartella...");
        _addTranslation("PAUSE UPLOAD", "Pausa upload");
        _addTranslation("CANCEL CHECK", "Annulla controllo");
        _addTranslation("Keep temp file", "Conserva file temporaneo");
        _addTranslation("Use HTTP(S) PROXY", "Usa proxy HTTP/HTTPS");
        _addTranslation("MERGING FILE...", "Unione file...");
        _addTranslation("Checking MEGA account...", "Verifica account Mega...");
        _addTranslation("SAVE", "Salva");
        _addTranslation("New download", "Nuovo download");
        _addTranslation("New upload", "Nuovo upload");
        _addTranslation("New streaming", "Nuovo streaming");
        _addTranslation("Split file", "Dividi file");
        _addTranslation("Merge file", "Unisci file");
        _addTranslation("Remove all no running downloads", "Rimuovi tutti i download non in esecuzione");
        _addTranslation("Remove all no running uploads", "Rimuovi tutti gli upload non in esecuzione");
        _addTranslation("Edit", "Modifica");
        _addTranslation("Settings", "Impostazioni");
        _addTranslation("Help", "Aiuto");
        _addTranslation("About", "Info programma");
        _addTranslation("Remember for this session", "Ricorda per questa sessione");
        _addTranslation("Restore folder data", "Ripristina cartella dati");
        _addTranslation("Restoring data, please wait...", "Ripristino dati...");
        _addTranslation("File", "File");
        _addTranslation("Hide to tray", "Nascondi in barra sistema");
        _addTranslation("Clear finished", "Rimuovi file completati da elenco");
        _addTranslation("Exit", "Esci");
        _addTranslation("Default slots per file:", "Slot predefiniti per file:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Nota: se vuoi scaricare senza usare un account PREMIUM MEGA è necessario abilitarlo (gli slot consumano RAM, usali moderatamente).");
        _addTranslation("Max speed (KB/s):", "Velocità massima (KB/s):");
        _addTranslation("Default account:", "Account predefinito:");
        _addTranslation("TCP Port:", "Porta TCP");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Nota: è NECESSARIO \"APRIRE\" questa porta nel router/firewall.");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Nota: abilita questa opzione per mitigare il limite di larghezza di banda (richiesto multi slot).");
        _addTranslation("Max parallel downloads:", "N. download contemporanei:");
        _addTranslation("Max parallel uploads:", "N. upload contemporanei:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Nota: gli slot consumano RAM, usali moderatamente.");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Nota: puoi usare un alias (opzionale) per i tuoi indirizzi email -> bob@supermail.com#bob_mail (non dimenticare di salvarlo dopo aver inserito i tuoi account).");
        _addTranslation("Your MEGA accounts:", "Account MEGA:");
        _addTranslation("Your ELC accounts:", "Account ELC:");
        _addTranslation("Note: restart required.", "Nota: è richiesto il riavvio");
        _addTranslation("Note: restart might be required.", "Nota: potrebbe essere necessario il riavvio.");
        _addTranslation("Font ZOOM (%):", "Zoom font (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Nota: MegaBasterd userà questo proxy per tutte le connessioni.");
        _addTranslation("Port:", "Porta:");
        _addTranslation("Settings successfully saved!", "Salvataggio impostazioni completato!");
        _addTranslation("Settings successfully imported!", "Importazione impostazioni completata!");
        _addTranslation("Settings successfully exported!", "Esportazioni impostazioni completata!");
        _addTranslation("Settings successfully reset!", "Ripristino impostazioni completato");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Si sono verificati errori con alcuni account (email e/o password errati).\nControllali:\n\n");
        _addTranslation("Settings saved", "Salvataggio impostazioni");
        _addTranslation("Settings imported", "Importazione impostazioni");
        _addTranslation("Settings exported", "Esportazione impostazioni");
        _addTranslation("Settings reset", "Ripristino impostazioni");
        _addTranslation("MegaBasterd will restart", "MegaBasterd verrà riavviato per applicare le nuove impostazioni");
        _addTranslation("Restart required", "Riavvio richiesto");
        _addTranslation("File is not readable!", "Il file non è leggibile");
        _addTranslation("Folder is not readable!", "La cartella non è leggibile");
        _addTranslation("BAD PASSWORD!", "Password errata");
        _addTranslation("Passwords does not match!", "Le password non corrispondono!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Incolla un collegamento Mega/megaCrypter/DLC!");
        _addTranslation("Yes", "Sì");
        _addTranslation("Cancel", "Annulla");
        _addTranslation("UNEXPECTED ERROR!", "Errore inatteso");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "Sembra che MegaBasterd è in streaming video.\nVuoi uscire?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "Sembra che MegaBasterd stia effettuando il provisioning/upload.\n\nSe esci ora, l'unprovisioned/upload andranno persi.\n\nVuoi continuare?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "Sembra che MegaBasterd stia finendo di caricare alcuni file.\n\nSe esci ora quegli upload falliranno.\n\nVuoi continuare?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Dopo l'importazione tutte le impostazioni e gli account attuali verranno eliminati (ti consigliamo di esportare le impostazioni attuali prima di importare quelle nuove).\n\nVuoi continuare?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Verranno esportate solo le impostazioni e gli account SALVATI (se non sei sicuro, è meglio salvare le impostazioni attuali e quindi esportarle).\n\nVuoi continuare?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "La password principale verrà reimpostata e tutti i tuoi account verranno rimossi (l'operazione non può essere annullata).\n\nVuoi continuare?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "Tutte e informazioni, gli account e i trasferimenti verranno rimossi (l'operazione non può essere annullata).\n\nVuoi continuare?");
        _addTranslation("Remove all no running downloads?", "Vuoi rimuovere tutti i download non in esecuzione?");
        _addTranslation("Warning!", "Attenzione!");
        _addTranslation("Remove all no running uploads?", "Vuoi rimuovere tutti gli upload non in esecuzione?");
        _addTranslation("Please, enter your master password", "Inserisci la tua password principale");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "Attenzione: se dimentichi questa password, dovrai inserire nuovamente tutti i tuoi account.");
        _addTranslation("New pass:", "Nuova password:");
        _addTranslation("Confirm new:", "Conferma password:");
        _addTranslation("Verifying your password, please wait...", "Verifica password...");
        _addTranslation("Processing your password, please wait...", "Elaborazione password...");
        _addTranslation("Downloads", "Download");
        _addTranslation("Uploads", "Upload");
        _addTranslation("Accounts", "Account");
        _addTranslation("Advanced", "Avanzate");
        _addTranslation("Language:", "Lingua");
        _addTranslation("English", "Inglese");
        _addTranslation("Spanish", "Spagnolo");
        _addTranslation("Loading files, please wait...", "Caricamento file...");
        _addTranslation("Checking account quota, please wait...", "Verifica quota account...");
        _addTranslation("ERROR checking account quota!", "ERRORE durante il controllo quota account!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Se non vuoi trasferire qualche cartella o file puoi rimuoverlo (per selezionare più elementi contemporaneamente usa CTRL + mouse sx).");
        _addTranslation("Upload name:", "Nome upload:");
        _addTranslation("Account:", "Account:");
        _addTranslation("Folder link detected!", "Rilevato collegamento cartella!");
        _addTranslation("File already exists!", "Il file esiste già!");
        _addTranslation("MegaBasterd is stopping transferences safely, please wait...", "MegaBasterd sta fermando i trasferimenti in sicurezza.\nAttendi...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "Incolla qui il collegamento MEGA/MegaCrypter/ELC (uno per riga):");
        _addTranslation("Download folder:", "Cartella download:");
        _addTranslation("Split size (MBs):", "Dim,. suddivisione (MB):");
        _addTranslation("File successfully splitted!", "Divisione file completata");
        _addTranslation("File successfully merged!", "Unione file completata!");
        _addTranslation("File successfuly downloaded!", "Download file completato!");
        _addTranslation("Download paused!", "Download in pausa!");
        _addTranslation("Downloading file from mega ...", "Download file da Mega...");
        _addTranslation("Copy link", "Copia collegamento");
        _addTranslation("Downloading file from mega ", "Download file da Mega");
        _addTranslation("EXIT NOW", "Esci ora");
        _addTranslation("Download CANCELED!", "Download annullato");
        _addTranslation("Upload CANCELED!", "Upload annullato");
        _addTranslation("Uploading file to mega (", "Upload file su Mega");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Per ottenere un collegamento streaming inserisci qui il collegamento MEGA/MegaCrypter/ELC:");
        _addTranslation("Use this account for streaming:", "Per lo streaming usa questo account:");
        _addTranslation("Use this account for download:", "Per il download usa questo account:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "Il collegamento in streaming è stato copiato negli Appunti!\nRicordati di mantenere MegaBasterd in esecuzione in background durante la riproduzione dei contenuti.");
        _addTranslation("CANCEL UPLOAD", "Annulla upload");
        _addTranslation("Upload paused!", "Upload in pausa");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "Arresto download in modo sicuro prima di uscire da MegaBasterd.\nAttendi...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "Arresto upload in modo sicuro prima di uscire da MegaBasterd.\nAttendi...");
        _addTranslation("Starting download, please wait...", "Avvio download. Attendi...");
        _addTranslation("Starting upload, please wait...", "Avvio upload. Attendi...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "Avvio download (recupero collegamento temporaneo Mega).\nAttendi...");
        _addTranslation("File exists, resuming download...", "Il file esiste. Ripresa download...");
        _addTranslation("Truncating temp file...", "Troncamento file temporaneo...");
        _addTranslation("Waiting to check file integrity...", "In attesa verifica integrità del file...");
        _addTranslation("Checking file integrity, please wait...", "Controllo integrità del file...");
        _addTranslation("Provisioning download, please wait...", "Provisioning download..");
        _addTranslation("Waiting to start...", "In attesa dell'avvio...");
        _addTranslation("Provisioning upload, please wait...", "Provisioning upload...");
        _addTranslation("Waiting to start (", "In attesa dell'avvio (");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Creazione nuovo nodo Mega (*** non uscire da MegaBasterd ora ***)...");
        _addTranslation("File successfully uploaded! (", "Upload file completato! (");
        _addTranslation("PAUSE ALL", "Metti in pausa tutto");
        _addTranslation("RESUME ALL", "Riprendi tutto");
        _addTranslation("MEGA folder link was copied to clipboard!", "Il collegamento cartella MEGA è stato copiato negli Appunti!");
        _addTranslation("MEGA file link was copied to clipboard!", "Il collegamento file Mega è stato copiato negli Appunti!");
        _addTranslation("Pausing download ...", "Pausa download...");
        _addTranslation("Pausing upload ...", "Pausa upload ");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "Download file completato (controllo di integrità completato)!");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "Download file completato (ma controllo di integrità annullato)!");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "Upload fallito (gestore completamento vuoto)!");
        _addTranslation("UPLOAD FAILED: too many errors", "Upload fallito: troppi errori");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "Upload fallito: errore fatale");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "Errore: il file è danneggiato!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "Collegamento Mega temporaneamente non disponibile!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "File temporaneamente non disponibile! (nuovo tentativo tra ");
        _addTranslation(" secs...)", " sec...");
        _addTranslation(" (Retrying in ", "(Nuovo tentativo tra");
        _addTranslation("Proxy settings", "Impostazioni proxy");
        _addTranslation("Authentication", "Autenticazione");
        _addTranslation("Upload info", "Info upload");
        _addTranslation("Files", "File");
        _addTranslation("Username:", "Nome utente");
        _addTranslation("Password:", "Password");
        _addTranslation("Link was copied to clipboard!", "Il collegamento è stato copiato negli Appunti!");
        _addTranslation("Checking if there are previous downloads, please wait...", "Verifica se ci sono download precedenti...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Verifica se ci sono upload precedenti...");
        _addTranslation("Restore window", "Ripristina finestra MegaBasterd");
        _addTranslation("EXIT", "Esci");
        _addTranslation("File successfully downloaded!", "Download file completato!");
        _addTranslation("Quota used: ", "Quota usata: ");
        _addTranslation("Streaming server: ON (port ", "Server streaming: ON (porta ");
        _addTranslation("MC reverse mode: ON (port ", "Modo inverso MC: ON (porta ");
        _addTranslation("Joining file chunks, please wait...", "Unione segmenti file...");
        _addTranslation("Close MegaBasterd when all transfers finish", "Chiudi MegaBasterd a trasferimenti completati");
        _addTranslation("Use custom temporary directory for chunks storage", "Per salvare i segmenti usa cartella temporanea personalizzata");
        _addTranslation("CANCEL ALL DOWNLOADS", "Annulla tutti i download");
        _addTranslation("Save debug info to file", "Salva info debug nel file");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "Il formato per l'elenco proxy è []IP:PORT[@user_b64:password_b64)");
        _addTranslation("Slots", "Slot");
        _addTranslation("MC reverse mode: OFF", "Modo MC inverso: OFF");
        _addTranslation("Pre:", "In preparazione:");
        _addTranslation("Pro:", "Pro:");
        _addTranslation("Wait:", "In attesa:");
        _addTranslation("Run:", "In download:");
        _addTranslation("Finish:", "Completati:");
        _addTranslation("Rem:", "Rem:");
        _addTranslation("Italian", "Italiano");
        _addTranslation("Chinese", "Cinese");
        _addTranslation("German", "Tedesco");
        _addTranslation("Hungarian", "Ungherese");
        _addTranslation("Turkish", "Turco");
        _addTranslation("Streaming server: OFF (port ", "Server streaming: OFF (porta ");
        _addTranslation("MC reverse mode: OFF (port ", "Mod MC inverso:(porta ");
        _addTranslation("SmartProxy: ON (port ", "SmaprtProxy: ON (porta ");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: OFF (porta ");
        _addTranslation("Link Grabber", "Cattura collegamenti");
        _addTranslation("Select DLC container", "Selezione contenitore DLC");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "Nessun account MEGA disponibile (vai in Impostazioni -> Account");
        _addTranslation("MEGA API KEY:", "Chiave API MEGA:");
        _addTranslation("MEGA API KEY ERROR", "Errore chiave API Mega");
        _addTranslation("An older version of MegaBasterd has been detected (", "È stata rilevata una versione precedente di MegaBasterd (");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ").\nVuoi importare tutte le impostazioni attuali e i trasferimenti dalla versione precedente?\nAttezione: possono esistere incompatibilità tra versioni.");
        _addTranslation("All your transferences have finished", "Tutti i trasferimenti sono stati completati");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "Host");
        _addTranslation("User", "Utente");
        _addTranslation("Password", "Password");
        _addTranslation("API-KEY", "Chiave API");
        _addTranslation("Test", "Test");
        _addTranslation("OK", "OK");
        _addTranslation("No", "No");
        _addTranslation("MC reverse mode: OFF", "Modo MC inverso: OFF");
        _addTranslation("Restore MegaBasterd window", "Ripristina finestra MegaBasterd");
        _addTranslation("Exit from MegaBasterd", "Esci da MegaBasterd");
        _addTranslation("Vietnamese", "Vietnamita");
        _addTranslation("Used space: 0.00GB", "Spazio usato: 0.00GB");
        _addTranslation("Open folder in browser", "Apri cartella nel browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creazione delle miniature ... *** Non uscire da Megabasterd!!! ***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Caricamento miniatura ... *** Non uscire da Megabasterd!!! ***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "Vuoi annullare tutti i download?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "Gli account Mega sono bloccati");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "Importa account (file)");
        _addTranslation("Monitor clipboard looking for new links", "Monitora appunti alla ricerca di nuovi collegamenti");
        _addTranslation("SURE?", "Sei sicuro?");

    }

    private void Chinese() {
        _addTranslation("COPY ALL", "全部复制");
        _addTranslation("ALL COPIED!", "全部复制!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "已存在相同名称大小的文件");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "警告: 在没有 API 密钥的情况下使用 MEGA API 可能会违反其使用条款. API 密钥获取地址 -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "警告: 在没有 API 密钥的情况下使用 MEGA API 可能会违反其使用条款. API 密钥获取地址 -> https://mega.nz/sdk");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "警告: 在没有 API 密钥的情况下使用 MEGA API 可能会违反其使用条款.\n\nAPI 密钥获取地址 -> https://mega.nz/sdk (并在 MegaBasterd 高级设置中进行设置).\n\n立即创建 API 密钥?");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "警告: 使用代理或 VPN 绕过 MEGA 的每日下载限制可能违反其使用条款. 使用此选项需您自担风险.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "达到 MEGA 下载限制时执行此命令:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "使用此代理列表 (而不是 MegaBasterd 中包含的那个) 格式为 [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "等待完成处理程序 ... ***不要退出 MEGABASTERD***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "完成计算CBC-MAC码 (可能需要一段时间) ... ***不要退出 MEGABASTERD***");
        _addTranslation("Split content in different uploads", "拆分上传内容");
        _addTranslation("Merge content in the same upload", "合并上传内容");
        _addTranslation("How do you want to proceed?", "请选择上传方式?");
        _addTranslation("Put on TOP of waiting queue", "置顶等待队列");
        _addTranslation("TOP", "置顶");
        _addTranslation("BOTTOM", "底部");
        _addTranslation("Freeze transferences before start", "开始前暂停传输");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "取消暂停传输");
        _addTranslation("(FROZEN) Waiting to start...", "(暂停) 等待开始...");
        _addTranslation("(FROZEN) Waiting to start (", "(暂停) 等待开始)");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "这个文件夹里有很多文件.\n并非所有链接都将立即提供以避免使 MegaBasterd 饱和");
        _addTranslation("You've tried to login too many times. Wait an hour.", "您尝试登录太多次. 等一个小时.");
        _addTranslation("MEGA LINK ERROR!", "MEGA 链接错误!");
        _addTranslation("Please enter 2FA PIN CODE", "请输入 2FA PIN 码");
        _addTranslation("Enable log file", "启用日志文件");
        _addTranslation("Font:", "字体:");
        _addTranslation("Loading...", "正在加载...");
        _addTranslation("DEFAULT", "默认");
        _addTranslation("ALTERNATIVE", "其他");
        _addTranslation("Download latest version", "下载最新版本");
        _addTranslation("PROVISION FAILED", "下载失败");
        _addTranslation("Error registering download: file is already downloading.", "注册下载时出错: 文件已在下载.");
        _addTranslation("FATAL ERROR! ", "致命错误! ");
        _addTranslation("ERROR: FILE NOT FOUND", "ERROR: 文件未找到");
        _addTranslation("Mega link is not valid! ", "Mega 链接无效! ");
        _addTranslation("Checking your MEGA accounts, please wait...", "检查您的 MEGA 帐户, 请稍等...");
        _addTranslation("Check for updates", "检查更新");
        _addTranslation("Checking, please wait...", "检查中, 请稍等...");
        _addTranslation("You have the latest version ;)", "有最新版本 ");
        _addTranslation("Copy MegaBasterd download URL", "复制 MegaBasterd 下载 URL");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Tonikelope 编译构建（没有保证）.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "官方 (and ugly) 跨平台的 MEGA 下载器/上传者/流媒体套件.");
        _addTranslation("MEGA URL was copied to clipboard!", "MEGA URL 已复制到剪贴板!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "MegaBasterd 新版本可用! -> ");
        _addTranslation("Selecting folder...", "选择文件夹...");
        _addTranslation("MERGE FILE", "合并 文件");
        _addTranslation("Delete parts after merge", "合并后删除部分");
        _addTranslation("Remove selected", "删除选中");
        _addTranslation("SPLIT FILE/s", "分割文件");
        _addTranslation("Encrypt on disk sensitive information", "加密磁盘敏感信息");
        _addTranslation("Allow using MEGA accounts for download/streaming", "允许使用 MEGA 帐户进行下载/流媒体");
        _addTranslation("Please wait...", "请稍等...");
        _addTranslation("CANCEL RETRY", "取消重试");
        _addTranslation("SPLITTING FILE...", "分割文件...");
        _addTranslation("Open folder", "打开文件夹");
        _addTranslation("RESUME DOWNLOAD", "继续下载");
        _addTranslation("Close", "关闭");
        _addTranslation("Add files", "添加文件");
        _addTranslation("IMPORT SETTINGS", "导入设置");
        _addTranslation("RESET MEGABASTERD", "重置 MEGABASTERD");
        _addTranslation("RESET ACCOUNTS", "重置 帐户");
        _addTranslation("Verify file integrity (when download is finished)", "验证文件完整性 (下载完成时)");
        _addTranslation("Let's dance, baby", "开始下载");
        _addTranslation("Unlock accounts", "解锁帐户");
        _addTranslation("Use MegaCrypter reverse mode", "使用 MegaCrypter 反向模式");
        _addTranslation("Select (any) file part", "选择 (任何) 文件部分");
        _addTranslation("Add folder", "添加文件夹");
        _addTranslation("Adding files, please wait...", "正在添加文件, 请稍候...");
        _addTranslation("Restart", "重新开始");
        _addTranslation("Use SmartProxy", "使用智能代理");
        _addTranslation("PAUSE DOWNLOAD", "暂停下载");
        _addTranslation("Change it", "更改");
        _addTranslation("EXPORT SETTINGS", "导出设置");
        _addTranslation("Change output folder", "更改输出文件夹");
        _addTranslation("Add account", "新增帐户");
        _addTranslation("Select file/s", "选择文件");
        _addTranslation("Opening file...", "打开文件...");
        _addTranslation("CANCEL DOWNLOAD", "取消下载");
        _addTranslation("REMOVE ALL EXCEPT THIS", "删除除此之外的所有内容");
        _addTranslation("Loading DLC, please wait...", "加载DLC, 请稍候...");
        _addTranslation("Changing output folder...", "更改输出文件夹...");
        _addTranslation("RESUME UPLOAD", "继续上传");
        _addTranslation("Limit upload speed", "上传速度限制");
        _addTranslation("CANCEL", "取消");
        _addTranslation("Use multi slot download mode", "使用多线程下载模式");
        _addTranslation("Selecting file...", "选择文件...");
        _addTranslation("Copy folder link", "复制文件夹链接");
        _addTranslation("Limit download speed", "下载速度限制");
        _addTranslation("REMOVE THIS", "删除这个");
        _addTranslation("Copy file link", "复制文件链接");
        _addTranslation("Load DLC container", "加载 DLC 容器");
        _addTranslation("Adding folder, please wait...", "正在添加文件夹, 请稍候...");
        _addTranslation("PAUSE UPLOAD", "暂停上传");
        _addTranslation("CANCEL CHECK", "取消检查");
        _addTranslation("Keep temp file", "保留临时文件");
        _addTranslation("Use HTTP(S) PROXY", "使用 HTTP(S) PROXY");
        _addTranslation("MERGING FILE...", "合并文件...");
        _addTranslation("Checking MEGA account...", "检查 MEGA 帐户...");
        _addTranslation("SAVE", "保存");
        _addTranslation("New download", "新建下载");
        _addTranslation("New upload", "新建上传");
        _addTranslation("New streaming", "新增流媒体");
        _addTranslation("Split file", "拆分文件");
        _addTranslation("Merge file", "合并文件");
        _addTranslation("Remove all no running downloads", "删除所有未运行的下载");
        _addTranslation("Remove all no running uploads", "删除所有未运行的上传");
        _addTranslation("Edit", "编辑");
        _addTranslation("Settings", "设置");
        _addTranslation("Help", "帮助");
        _addTranslation("About", "关于");
        _addTranslation("Remember for this session", "记住本次会话");
        _addTranslation("Restore folder data", "恢复文件夹数据");
        _addTranslation("Restoring data, please wait...", "正在恢复数据, 请稍候...");
        _addTranslation("File", "文件");
        _addTranslation("Hide to tray", "隐藏到托盘");
        _addTranslation("Clear finished", "清除完成");
        _addTranslation("Exit", "退出");
        _addTranslation("Default slots per file:", "每个文件的默认线程:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "注意: 如果您想在不使用 MEGA PREMIUM 帐户的情况下下载, 您应该启用它. (线程会消耗 RAM, 因此请适度使用它们).");
        _addTranslation("Max speed (KB/s):", "最大速度 (KB/s):");
        _addTranslation("Default account:", "默认帐户:");
        _addTranslation("TCP Port:", "TCP 端口:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "注意: 这是强制性的 \"打开\" 路由器上的这个端口/firewall.");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "注意: 启用它以减轻带宽限制. (需要多线程).");
        _addTranslation("Max parallel downloads:", "最大下载并行:");
        _addTranslation("Max parallel uploads:", "最大上传并行:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "注意: 线程会消耗 RAM, 因此请适度使用它们.");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "注意: 可以使用一个 (选择) 您的电子邮件地址的别名 -> bob@supermail.com#bob_mail (输入您的帐户后不要忘记保存).");
        _addTranslation("Your MEGA accounts:", "您的 MEGA 帐户:");
        _addTranslation("Your ELC accounts:", "您的 ELC 帐户:");
        _addTranslation("Note: restart required.", "注意: 需要重启.");
        _addTranslation("Note: restart might be required.", "注意: 可能需要重新启动.");
        _addTranslation("Font ZOOM (%):", "字体 缩放 (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "注意: MegaBasterd 将使用此代理进行所有连接.");
        _addTranslation("Port:", "端口:");
        _addTranslation("Settings successfully saved!", "设置保存成功!");
        _addTranslation("Settings successfully imported!", "导入设置成功!");
        _addTranslation("Settings successfully exported!", "导出设置成功!");
        _addTranslation("Settings successfully reset!", "重置设置成功!");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "部分帐号存在错误 (email 和/或密码是/错误). 请检查:\n\n");
        _addTranslation("Settings saved", "设置已保存");
        _addTranslation("Settings imported", "导入设置");
        _addTranslation("Settings exported", "导出设置");
        _addTranslation("Settings reset", "重置设置");
        _addTranslation("MegaBasterd will restart", "MegaBasterd 将重新启动");
        _addTranslation("Restart required", "需要重启");
        _addTranslation("File is not readable!", "文件不可读");
        _addTranslation("Folder is not readable!", "文件夹不可读");
        _addTranslation("BAD PASSWORD!", "密码错误!");
        _addTranslation("Passwords does not match!", "密码不匹配!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "请粘贴或输入 Mega/MegaCrypter/ELC 链接!");
        _addTranslation("Yes", "确定");
        _addTranslation("Cancel", "取消");
        _addTranslation("UNEXPECTED ERROR!", "意外错误!");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "似乎 MegaBasterd 正在流式传输视频. 你确定继续吗?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "似乎 MegaBasterd 正在减少配置/上传.\n\n如果你现在退出, 取消配置/上传将丢失.\n\n你确定继续吗?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "似乎 MegaBasterd 刚刚完成了一些文件上传.\n\n如果您现在退出, 这些上传将失败.\n\n你确定继续吗?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "导入后将删除您当前的所有设置和帐户. (建议在导入前导出当前设置). \n\n你确定继续吗?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "只会导出保存的设置和帐户. (如果您不确定, 最好保存当前设置 然后导出).\n\n你确定继续吗?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "主密码将被重置, 您的所有帐户都将被删除. (将无法撤消)\n\n你确定继续吗?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "您的所有设置, 帐户和转账都将被删除. (将无法撤消)\n\n你确定继续吗?");
        _addTranslation("Remove all no running downloads?", "删除所有未运行的下载?");
        _addTranslation("Warning!", "警告!");
        _addTranslation("Remove all no running uploads?", "删除所有未运行的上传?");
        _addTranslation("Please, enter your master password", "请输入您的主密码");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "警告: 如果您忘记了此密码, 您需要重新插入所有帐户.");
        _addTranslation("New pass:", "新增通行证:");
        _addTranslation("Confirm new:", "确认新增:");
        _addTranslation("Verifying your password, please wait...", "正在验证密码, 请稍候...");
        _addTranslation("Processing your password, please wait...", "正在处理密码, 请稍候...");
        _addTranslation("Downloads", "下载");
        _addTranslation("Uploads", "上传");
        _addTranslation("Accounts", "账户");
        _addTranslation("Advanced", "高级");
        _addTranslation("Language:", "语言:");
        _addTranslation("English", "English");
        _addTranslation("Spanish", "Spanish");
        _addTranslation("Loading files, please wait...", "正在加载文件, 请稍候...");
        _addTranslation("Checking account quota, please wait...", "正在查看账户配额, 请稍候...");
        _addTranslation("ERROR checking account quota!", "检查帐户配额时出错!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "如果您不想传输某些文件夹或文件, 您可以删除它 (同时选择多个项目使用 CTRL + LMOUSE).");
        _addTranslation("Upload name:", "上传名称:");
        _addTranslation("Account:", "帐户:");
        _addTranslation("Folder link detected!", "检测到文件夹链接!");
        _addTranslation("File already exists!", "文件已存在!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "Megabasterd 正在安全地停止转移, 请稍等...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "请输入 MEGA/MegaCrypter/ELC  链接 (每行一个):");
        _addTranslation("Download folder:", "下载目录:");
        _addTranslation("Split size (MBs):", "分割尺寸 (MBs):");
        _addTranslation("File successfully splitted!", "文件拆分成功!");
        _addTranslation("File successfully merged!", "文件合并成功!");
        _addTranslation("File successfuly downloaded!", "文件下载成功!");
        _addTranslation("Download paused!", "暂停下载!");
        _addTranslation("Downloading file from mega ...", "从 MEGA 下载文件 ...");
        _addTranslation("Copy link", "复制链接");
        _addTranslation("Downloading file from mega ", "从 MEGA 下载文件 ");
        _addTranslation("EXIT NOW", "立即退出");
        _addTranslation("Download CANCELED!", "下载已取消!");
        _addTranslation("Upload CANCELED!", "上传已取消!");
        _addTranslation("Uploading file to mega (", "上传文件到 MEGA");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "请输入 MEGA/MegaCrypter/ELC 链接以获得流媒体链接:");
        _addTranslation("Use this account for streaming:", "使用此帐户进行流式传输:");
        _addTranslation("Use this account for download:", "使用此帐户下载:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "流媒体链接已复制到剪贴板!\n记得在播放内容时让 MegaBasterd 在后台运行.");
        _addTranslation("CANCEL UPLOAD", "取消上传");
        _addTranslation("Upload paused!", "上传已暂停!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "退出 MegaBasterd 前安全停止下载, 请稍候...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "退出 MegaBasterd 前安全停止上传, 请稍候...");
        _addTranslation("Starting download, please wait...", "开始下载, 请稍候...");
        _addTranslation("Starting upload, please wait...", "开始上传, 请稍候...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "开始下载 (检索 MEGA 临时链接), 请稍等...");
        _addTranslation("File exists, resuming download...", "文件存在, 正在恢复下载...");
        _addTranslation("Truncating temp file...", "截断临时文件...");
        _addTranslation("Waiting to check file integrity...", "等待检查文件完整性...");
        _addTranslation("Checking file integrity, please wait...", "正在检查文件完整性, 请稍候...");
        _addTranslation("Provisioning download, please wait...", "下载配置, 请稍候...");
        _addTranslation("Waiting to start...", "等待开始...");
        _addTranslation("Provisioning upload, please wait...", "配置上传, 请稍候...");
        _addTranslation("Waiting to start (", "等待开始");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "创建新的 MEGA 节点 ... ***不要退出 MEGABASTERD***");
        _addTranslation("File successfully uploaded! (", "文件上传成功!");
        _addTranslation("PAUSE ALL", "暂停所有");
        _addTranslation("RESUME ALL", "恢复所有");
        _addTranslation("MEGA folder link was copied to clipboard!", "MEGA 文件夹链接已复制到剪贴板!");
        _addTranslation("MEGA file link was copied to clipboard!", "MEGA 文件链接已复制到剪贴板!");
        _addTranslation("Pausing download ...", "暂停下载 ...");
        _addTranslation("Pausing upload ...", "暂停上传 ...");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "文件下载成功! (完整性检查通过)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "文件下载成功! (但完整性检查已取消)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "上传失败! (空完成处理程序!)");
        _addTranslation("UPLOAD FAILED: too many errors", "上传失败: 错误过多 请重试");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "上传失败: 致命错误 请重试");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "坏消息 :( 文件已损坏!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "MEGA 链接暂时不可用!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "文件暂时不可用! (请重试 ");
        _addTranslation(" secs...)", " 秒...");
        _addTranslation(" (Retrying in ", " (重试 ");
        _addTranslation("Proxy settings", "代理设置");
        _addTranslation("Authentication", "验证");
        _addTranslation("Upload info", "上传信息");
        _addTranslation("Files", "文件");
        _addTranslation("Username:", "用户名:");
        _addTranslation("Password:", "密码:");
        _addTranslation("Link was copied to clipboard!", "链接已复制到剪贴板!");
        _addTranslation("Checking if there are previous downloads, please wait...", "检查是否有以前的下载, 请稍等...");
        _addTranslation("Checking if there are previous uploads, please wait...", "检查是否有以前的上传, 请稍等...");
        _addTranslation("Restore window", "恢复窗口");
        _addTranslation("EXIT", "退出");
        _addTranslation("File successfully downloaded!", "文件下载成功!");
        _addTranslation("Quota used: ", "配额使用: ");
        _addTranslation("Streaming server: ON (port ", "流媒体服务器: ON (端口 ");
        _addTranslation("MC reverse mode: ON (port ", "MC 反向模式: ON (端口 ");
        _addTranslation("Joining file chunks, please wait...", "加入文件块, 请稍等...");
        _addTranslation("Close MegaBasterd when all transfers finish", "所有传输完成后关闭 MegaBasterd");
        _addTranslation("Use custom temporary directory for chunks storage", "使用自定义临时目录进行存储");
        _addTranslation("CANCEL ALL DOWNLOADS", "取消所有下载");
        _addTranslation("Save debug info to file", "将调试信息保存为");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "使用此代理列表格式为 [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "线程");
        _addTranslation("MC reverse mode: OFF", "MC反向模式：OFF");
        _addTranslation("Pre:", "预:");
        _addTranslation("Pro:", "Pro:");
        _addTranslation("Wait:", "等待:");
        _addTranslation("Run:", "下载中:");
        _addTranslation("Finish:", "完成:");
        _addTranslation("Rem:", "Rem:");
        _addTranslation("Italian", "Italian");
        _addTranslation("Chinese", "Chinese");
        _addTranslation("German", "German");
        _addTranslation("Hungarian", "Hungarian");
        _addTranslation("Turkish", "Turkish");
        _addTranslation("Streaming server: OFF (port ", "流媒体服务器: OFF (端口");
        _addTranslation("MC reverse mode: OFF (port ", "MC 反向模式：OFF");
        _addTranslation("SmartProxy: ON (port ", "智能代理：ON (端口");
        _addTranslation("SmartProxy: OFF (port ", "智能代理：OFF");
        _addTranslation("Link Grabber", "请输入下载链接");
        _addTranslation("Select DLC container", "选择 DLC 容器");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "没有可用的 MEGA 帐户 (前往设置 > 账户)");
        _addTranslation("MEGA API KEY:", "MEGA API KEY:");
        _addTranslation("MEGA API KEY ERROR", "MEGA API KEY 错误");
        _addTranslation("An older version of MegaBasterd has been detected (", "已检测到旧版本的 MegaBasterd");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ".\n是否要从以前的版本导入所有当前设置和传输?\n警告：版本之间可能存在不兼容性.");
        _addTranslation("All your transferences have finished", "所有转移已完成");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "域名/IP");
        _addTranslation("User", "用户名");
        _addTranslation("Password", "密码");
        _addTranslation("API-KEY", "API-KEY");
        _addTranslation("Test", "测试");
        _addTranslation("OK", "确定");
        _addTranslation("No", "否");
        _addTranslation("MC reverse mode: OFF", "MC反向模式：OFF");
        _addTranslation("Restore MegaBasterd window", "恢复 MegaBasterd 窗口");
        _addTranslation("Exit from MegaBasterd", "退出 MegaBasterd");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Used space: 0.00GB");
        _addTranslation("Open folder in browser", "Open folder in browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "CANCEL ALL DOWNLOADS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "MEGA ACCOUNTS ARE LOCKED");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORT ACCOUNTS (FILE)");
        _addTranslation("Monitor clipboard looking for new links", "Monitor clipboard looking for new links");
        _addTranslation("SURE?", "SURE?");
    }

    private void Turkish() {
        _addTranslation("COPY ALL", "HEPSİNİ KOPYALA");
        _addTranslation("ALL COPIED!", "HEPSİ KOPYALANDI!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "AYNI AD VE BOYUTTA DOSYA ZATEN MEVCUT");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "UYARI: MEGA API'nin API ANAHTARI OLMADAN KULLANIMI, KULLANIM KOŞULLARINI İHLAL EDEBİLİR. BİR ANAHTAR ALMALISINIZ -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "UYARI: MEGA API'yi API ANAHTARI OLMADAN KULLANMAK, KULLANIM KOŞULLARINI İHLAL EDEBİLİR.\n\nBİR ANAHTAR ALMALISINIZ -> https://mega.nz/sdk (ve MegaBasterd GELİŞMİŞ AYARLAR'dan ayarlayın).\n\nAPI ANAHTARI ŞİMDİ OLUŞTURUN?");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "UYARI: MEGA'nın günlük indirme sınırlamasını aşmak için proxy veya VPN kullanmak, Kullanım Koşullarını ihlal edebilir. BU SEÇENEĞİ KULLAN, RİSKİ SİZE AİTTİR");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "MEGA'nın günlük indirme sınırlamasını atlamak için proxy veya VPN kullanmak, Kullanım Koşullarını ihlal edebilir..");
        _addTranslation("Execute this command when MEGA download limit is reached:", "MEGA indirme sınırına ulaşıldığında bu komutu yürütün:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "Bu proxy listesini kullanın (MegaBasterd'de bulunanın yerine) Format: [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "Tamamlama işleyicisi bekleniyor... ***MEGABASTERD'DEN ŞİMDİ ÇIKMAYIN***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "CBC-MAC kodunun hesaplanması bitiyor (bu biraz zaman alabilir) ... ***MEGABASTERD'DEN ŞİMDİ ÇIKMAYIN***");
        _addTranslation("Split content in different uploads", "İçerikleri farklı bölümlere ayır");
        _addTranslation("Merge content in the same upload", "Aynı içerikleri yüklemede birleştir");
        _addTranslation("How do you want to proceed?", "Nasıl devam etmek istiyorsunuz");
        _addTranslation("Put on TOP of waiting queue", "Bekleyen indirmeleri ekran üzerinde sabitle");
        _addTranslation("TOP", "Üst tepsi");
        _addTranslation("BOTTOM", "Alt");
        _addTranslation("Freeze transferences before start", "Başlamadan önce aktarımları dondurun");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "BEKLEYEN TRANSFERLERİ BIRAKIN");
        _addTranslation("(FROZEN) Waiting to start...", "(DONDURULMUŞ) Başlamak için bekleniyor...");
        _addTranslation("(FROZEN) Waiting to start (", "(DONDURULMUŞ) Başlamak için bekleniyor (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Bu klasörde çok sayıda dosya var.\nMegaBasterd için tüm bağlantılar aynı anda sağlanmayacak");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Çok fazla giriş yapmayı denediniz. bir saat bekleyin.");
        _addTranslation("MEGA LINK ERROR!", "MEGA BAĞLANTI HATASI!");
        _addTranslation("Please enter 2FA PIN CODE", "Lütfen 2FA PIN KODU girin");
        _addTranslation("Enable log file", "Günlük dosyasını etkinleştirin");
        _addTranslation("Font:", "Yazı tipi:");
        _addTranslation("Loading...", "Yükleniyor...");
        _addTranslation("DEFAULT", "VARSAYILAN");
        _addTranslation("ALTERNATIVE", "ALTERNATİF");
        _addTranslation("Download latest version", "En son sürümü indirin");
        _addTranslation("PROVISION FAILED", "BAŞARISIZ");
        _addTranslation("Error registering download: file is already downloading.", "İndirme kaydedilirken hata oluştu: dosya zaten indiriliyor.");
        _addTranslation("FATAL ERROR! ", "HATA OLUŞTU! ");
        _addTranslation("ERROR: FILE NOT FOUND", "HATA DOSYA BULUNAMADI");
        _addTranslation("Mega link is not valid! ", "Mega bağlantısı geçerli değil! ");
        _addTranslation("Checking your MEGA accounts, please wait...", "MEGA hesaplarınız kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("Check for updates", "Güncellemeleri kontrol et");
        _addTranslation("Checking, please wait...", "Kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("You have the latest version ;)", "En son sürüme sahipsiniz ;)");
        _addTranslation("Copy MegaBasterd download URL", "MegaBasterd indirme URL'sini kopyalayın");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Tonikelope tarafından sevgiyle (ve garantisiz) yapılmıştır.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Yine bir başka resmi olmayan çapraz platform.");
        _addTranslation("MEGA URL was copied to clipboard!", "MEGA URL'si panoya kopyalandı!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "MegaBasterd YENİ VERSİYON mevcut! -> ");
        _addTranslation("Selecting folder...", "Klasör seç...");
        _addTranslation("MERGE FILE", "DOSYA BİRLEŞTİRME");
        _addTranslation("Delete parts after merge", "Birleştirmeden sonra parçaları sil");
        _addTranslation("Remove selected", "Seçilenleri kaldır");
        _addTranslation("SPLIT FILE/s", "BÖLÜNMÜŞ DOSYA");
        _addTranslation("Encrypt on disk sensitive information", "Disk üzerindeki hassas bilgileri şifreleyin");
        _addTranslation("Allow using MEGA accounts for download/streaming", "MEGA hesaplarının kullanılmasına izin ver");
        _addTranslation("Please wait...", "Lütfen bekleyin...");
        _addTranslation("CANCEL RETRY", "İPTAL TEKRAR DENE");
        _addTranslation("SPLITTING FILE...", "AYRILMIŞ DOSYALAR...");
        _addTranslation("Open folder", "Klasörü aç");
        _addTranslation("RESUME DOWNLOAD", "İNDİRMEYE DEVAM ET");
        _addTranslation("Close", "Kapat");
        _addTranslation("Add files", "Dosya ekle");
        _addTranslation("IMPORT SETTINGS", "AYARLARI İÇERİ AKTAR");
        _addTranslation("RESET MEGABASTERD", "MEGABASTERD SIFIRLA");
        _addTranslation("RESET ACCOUNTS", "HESAPLARI KALDIR");
        _addTranslation("Verify file integrity (when download is finished)", "Dosya bütünlüğünü doğrulayın (indirme bittiğinde)");
        _addTranslation("Let's dance, baby", "İndirmeyi Başlat");
        _addTranslation("Unlock accounts", "Hesapların kilidini aç");
        _addTranslation("Use MegaCrypter reverse mode", "MegaCrypter ters modunu kullanın");
        _addTranslation("Select (any) file part", "(Herhangi bir) dosya bölümünü seçin");
        _addTranslation("Add folder", "Dosya ekle");
        _addTranslation("Adding files, please wait...", "Dosyalar ekleniyor,lütfen bekleyin...");
        _addTranslation("Restart", "Yeniden başlat");
        _addTranslation("Use SmartProxy", "Proxy kullan");
        _addTranslation("PAUSE DOWNLOAD", "İNDİRMEYİ DURAKLAT");
        _addTranslation("Change it", "Değiştir");
        _addTranslation("EXPORT SETTINGS", "AYARLARI AKTAR");
        _addTranslation("Change output folder", "KAYDETME KLASÖRÜNÜ DEĞİŞTİR");
        _addTranslation("Add account", "Hesap ekle");
        _addTranslation("Select file/s", "Dosya seçin");
        _addTranslation("Opening file...", "Dosya açılıyor...");
        _addTranslation("CANCEL DOWNLOAD", "İNDİRMEYİ İPTAL ET");
        _addTranslation("REMOVE ALL EXCEPT THIS", "BUNUN DIŞINDA TÜMÜNÜ KALDIRIN");
        _addTranslation("Loading DLC, please wait...", "DLC yükleniyor, lütfen bekleyin...");
        _addTranslation("Changing output folder...", "Çıktı klasörü değiştiriliyor...");
        _addTranslation("RESUME UPLOAD", "YÜKLEMEYE DEVAM ET");
        _addTranslation("Limit upload speed", "Yükleme hızını sınırla");
        _addTranslation("CANCEL", "İPTAL");
        _addTranslation("Use multi slot download mode", "Çoklu indirme modunu kullan");
        _addTranslation("Selecting file...", "Dosya seçiliyor....");
        _addTranslation("Copy folder link", "Klasör bağlantısını kopyala");
        _addTranslation("Limit download speed", "indirme hızını sınırla");
        _addTranslation("REMOVE THIS", "BUNU KALDIR");
        _addTranslation("Copy file link", "Dosya bağlantısını kopyala");
        _addTranslation("Load DLC container", "DLC kapsayıcısını yükle");
        _addTranslation("Adding folder, please wait...", "Klasör ekleniyor, lütfen bekleyin...");
        _addTranslation("PAUSE UPLOAD", "YÜKLEMEYİ DURAKLAT");
        _addTranslation("CANCEL CHECK", "KONTROL ETMEYİ İPTAL ET");
        _addTranslation("Keep temp file", "Geçici dosyayı tut");
        _addTranslation("Use HTTP(S) PROXY", "HTTP(S) PROXY kullanın");
        _addTranslation("MERGING FILE...", "DOSYA BİRLEŞTİRİLİYOR...");
        _addTranslation("Checking MEGA account...", "MEGA hesabını kontrol ediliyor...");
        _addTranslation("SAVE", "KAYDET");
        _addTranslation("New download", "Yeni indirme");
        _addTranslation("New upload", "Yeni yükleme");
        _addTranslation("New streaming", "Yeni akış");
        _addTranslation("Split file", "Dosya bölme");
        _addTranslation("Merge file", "Dosya birleştirme");
        _addTranslation("Remove all no running downloads", "Çalışan tüm indirmeleri kaldır");
        _addTranslation("Remove all no running uploads", "Çalışan tüm yüklemeleri kaldır");
        _addTranslation("Edit", "Düzenle");
        _addTranslation("Settings", "Ayarlar");
        _addTranslation("Help", "Yardım");
        _addTranslation("About", "Hakkında & Türkçe çeviri: FabSec; By Fabriel");
        _addTranslation("Remember for this session", "Bu oturum için hatırla");
        _addTranslation("Restore folder data", "Klasörü geri yükle");
        _addTranslation("Restoring data, please wait...", "Veriler geri yükleniyor, lütfen bekleyin...");
        _addTranslation("File", "Dosya");
        _addTranslation("Hide to tray", "Tepsiye gizle");
        _addTranslation("Clear finished", "indirilenleri listeden temizle");
        _addTranslation("Exit", "Çıkış");
        _addTranslation("Default slots per file:", "Dosya başına varsayılan slot:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Not: Bir MEGA PREMIUM hesabı kullanmadan indirmek istiyorsanız, onu etkinleştirmeniz GEREKİR. (RAM tüketir, bu nedenle bu ayarı dengeli kullanın).");
        _addTranslation("Max speed (KB/s):", "Max hız (KB/s):");
        _addTranslation("Default account:", "Varsayılan hesap:");
        _addTranslation("TCP Port:", "TCP port:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Not: yönlendiricinizde/güvenlik duvarınızda bağlantı noktasını\"AÇMALISINIZ.");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Not: Bant genişliği sınırını azaltmak için etkinleştirin.(RAM gerekli.");
        _addTranslation("Max parallel downloads:", "Maksimum paralel indirme:");
        _addTranslation("Max parallel uploads:", "Maksimum paralel yükleme:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Not: RAM tüketir, bu nedenle bu ayarı dengeli kullanın.");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Not: E-posta adresleriniz için (isteğe bağlı) bir takma ad kullanabilirsiniz -> fabriel@supermail.com#fabriel_mail (hesaplarınızı girdikten sonra kaydetmeyi unutmayın).");
        _addTranslation("Your MEGA accounts:", "MEGA hesaplarınız:");
        _addTranslation("Your ELC accounts:", "ELC hesaplarınız:");
        _addTranslation("Note: restart required.", "Not: yeniden başlatma gerekli.");
        _addTranslation("Note: restart might be required.", "Not: yeniden başlatma gerekebilir.");
        _addTranslation("Font ZOOM (%):", "Yazı Tipi yakınlaştırma (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Not: MegaBasterd bu proxy TÜM bağlantılar için kullanacaktır..");
        _addTranslation("Port:", "Port/Giriş:");
        _addTranslation("Settings successfully saved!", "Ayarlar başarıyla kaydedildi!");
        _addTranslation("Settings successfully imported!", "Ayarlar başarıyla içeri aktarıldı!");
        _addTranslation("Settings successfully exported!", "Ayarlar başarıyla dışarı aktarıldı!");
        _addTranslation("Settings successfully reset!", "Ayarlar başarıyla sıfırlandı!");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Bazı hesaplarda hatalar oluştu (e-posta ve/veya şifre yanlış/yanlış). Lütfen kontrol edin:\n\n");
        _addTranslation("Settings saved", "Ayarlar kaydedildi");
        _addTranslation("Settings imported", "Ayarlar içeri aktarıldı");
        _addTranslation("Settings exported", "Ayarlar dışarı aktarıldı");
        _addTranslation("Settings reset", "Ayarlar sıfırlandı");
        _addTranslation("MegaBasterd will restart", "MegaBasterd yeniden başlayacak");
        _addTranslation("Restart required", "Yeniden başlatma gerekiyor");
        _addTranslation("File is not readable!", "Dosya okunamıyor");
        _addTranslation("Folder is not readable!", "Klasör okunamıyor");
        _addTranslation("BAD PASSWORD!", "YANLIŞ PAROLA!");
        _addTranslation("Passwords does not match!", "Parolalar eşleşmiyor!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Lütfen bir Mega/MegaCrypter/ELC bağlantısı yapıştırın!");
        _addTranslation("Yes", "Evet");
        _addTranslation("Cancel", "iptal");
        _addTranslation("UNEXPECTED ERROR!", "BEKLENMEDİK HATA!");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "Görünüşe göre MegaBasterd video akışı yapıyor. çıkmak istiyor musunuz?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "Görünüşe göre MegaBasterd indirme/yükleme sağlıyor.\n\nŞimdi çıkarsanız, temel hazırlığı yapılmamış indirme/yüklemeler kaybolacak.\n\nDevam etmek istiyor musunuz?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "MegaBasterd bazı dosyaları yüklemeyi yeni bitiriyor gibi görünüyor.\n\nŞİMDİ ÇIKIRSANIZ, BU YÜKLEMELER BAŞARISIZ OLACAK.\n\nDevam etmek istiyor musunuz?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Tüm mevcut ayarlarınız ve hesaplarınız içe aktarıldıktan sonra silinecek. (İçe aktarmadan önce mevcut ayarlarınızı dışa aktarmanız önerilir). \n\nDevam etmek istiyor musunuz?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Yalnızca KAYITLI ayarlar ve hesaplar dışa aktarılacaktır. (Emin değilseniz, mevcut ayarlarınızı kaydedip ardından dışa aktarmanız daha iyi olur).\n\nDevam etmek istiyor musunuz?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "Ana şifre sıfırlanacak ve tüm hesaplarınız kaldırılacak. (BU GERİ ALINAMAZ)\n\nDevam etmek istiyor musunuz?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "TÜM AYARLARINIZ, HESAPLARINIZ VE TRANSFERLERİNİZ KALDIRILACAKTIR. (BU GERİ ALINAMAZ)\n\nDevam etmek istiyor musunuz?");
        _addTranslation("Remove all no running downloads?", "Çalışan tüm indirmeleri kaldır?");
        _addTranslation("Warning!", "Uyarı!");
        _addTranslation("Remove all no running uploads?", "Tüm çalışan yüklemeleri kaldır?");
        _addTranslation("Please, enter your master password", "Lütfen ana şifrenizi girin");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "UYARI: Bu şifreyi unutursanız, tüm hesaplarınızı tekrar girmeniz gerekecektir.");
        _addTranslation("New pass:", "Yeni şifre:");
        _addTranslation("Confirm new:", "Yeni şifreyi onayla:");
        _addTranslation("Verifying your password, please wait...", "Parolanız doğrulanıyor, lütfen bekleyin...");
        _addTranslation("Processing your password, please wait...", "Şifreniz işleniyor, lütfen bekleyin...");
        _addTranslation("Downloads", "İndirilenler");
        _addTranslation("Uploads", "Yüklemeler");
        _addTranslation("Accounts", "Hesaplar");
        _addTranslation("Advanced", "Gelişmiş");
        _addTranslation("Language:", "Diller:");
        _addTranslation("English", "İngilizce");
        _addTranslation("Spanish", "İspanyolca");
        _addTranslation("Loading files, please wait...", "Dosyalar yükleniyor, lütfen bekleyin...");
        _addTranslation("Checking account quota, please wait...", "Hesap kotası kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("ERROR checking account quota!", "HATA hesap kotası kontrol ediliyor!");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Bazı klasörleri veya dosyaları aktarmak İSTEMİYORSANIZ, KALDIRABİLİRSİNİZ (birkaç öğeyi aynı anda seçmek için CTRL + LMOUSE tuşlarını kullanın.)");
        _addTranslation("Upload name:", "Seçileni Yükle:");
        _addTranslation("Account:", "Hesap:");
        _addTranslation("Folder link detected!", "Klasör bağlantısı algılandı!");
        _addTranslation("File already exists!", "Dosya zaten mevcut!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "Megabasterd aktarımları güvenli bir şekilde durduruyor, lütfen bekleyin...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "MEGA/MegaCrypter/ELC bağlantılarınızı buraya koyun (her satıra bir tane):");
        _addTranslation("Download folder:", "indirme klasörü:");
        _addTranslation("Split size (MBs):", "Bölünme boyutu (MBs):");
        _addTranslation("File successfully splitted!", "Dosya başarıyla bölündü!");
        _addTranslation("File successfully merged!", "Dosya başarıyla birleştirildi!");
        _addTranslation("File successfuly downloaded!", "Dosya başarıyla indirildi!");
        _addTranslation("Download paused!", "indirme duraklatıldı!");
        _addTranslation("Downloading file from mega ...", "Mega tarafından indirilen dosya ...");
        _addTranslation("Copy link", "Bağlantıyı kopyala");
        _addTranslation("Downloading file from mega ", "Mega tarafından indirilen dosya ");
        _addTranslation("EXIT NOW", "ŞİMDİ ÇIK");
        _addTranslation("Download CANCELED!", "indirme İPTAL EDİLDİ!");
        _addTranslation("Upload CANCELED!", "Yükleme İPTAL EDİLDİ!");
        _addTranslation("Uploading file to mega (", "Dosya megaya yükleniyor");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Akış bağlantısını almak için MEGA/MegaCrypter/ELC bağlantınızı buraya koyun:");
        _addTranslation("Use this account for streaming:", "Akış için bu hesabı kullanın:");
        _addTranslation("Use this account for download:", "İndirmek için bu hesabı kullanın:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "Akış bağlantısı panoya kopyalandı!\nİçerik oynatılırken MegaBasterd'ın arka planda çalışmaya devam etmesini unutmayın.");
        _addTranslation("CANCEL UPLOAD", "YÜKLEME İPTAL");
        _addTranslation("Upload paused!", "YÜKLEME DURAKLATILDI!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "MegaBasterd'den çıkmadan önce indirmeyi güvenli bir şekilde durduruyor, lütfen bekleyin...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "MegaBasterd'den çıkmadan önce yükleme güvenli bir şekilde durduruluyor, lütfen bekleyin...");
        _addTranslation("Starting download, please wait...", "İndirmeye başlıyor, lütfen bekleyin...");
        _addTranslation("Starting upload, please wait...", "Yükleme başlatılıyor, lütfen bekleyin...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "İndirme başlatılıyor (MEGA geçici bağlantısı alınıyor), lütfen bekleyin...");
        _addTranslation("File exists, resuming download...", "Dosya mevcut, indirmeye devam ediliyor....");
        _addTranslation("Truncating temp file...", "Geçici dosya kesiliyor...");
        _addTranslation("Waiting to check file integrity...", "Dosya bütünlüğünü kontrol etmek için bekleniyor...");
        _addTranslation("Checking file integrity, please wait...", "Dosya bütünlüğü kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("Provisioning download, please wait...", "indirme hazırlanıyor, lütfen bekleyin...");
        _addTranslation("Waiting to start...", "Başlaması bekleniyor...");
        _addTranslation("Provisioning upload, please wait...", "Yükleme ön hazırlığı yapılıyor, lütfen bekleyin...");
        _addTranslation("Waiting to start (", "Başlaması bekleniyor");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Yeni MEGA düğümü oluşturuluyor ... ***MEGABASTERD'DEN ŞİMDİ ÇIKMAYIN***");
        _addTranslation("File successfully uploaded! (", "Dosya başarıyla yüklendi!");
        _addTranslation("PAUSE ALL", "HEPSİNİ DURDUR");
        _addTranslation("RESUME ALL", "HEPSİNİ DEVAM ETTİR");
        _addTranslation("MEGA folder link was copied to clipboard!", "MEGA klasör bağlantısı panoya kopyalandı!");
        _addTranslation("MEGA file link was copied to clipboard!", "MEGA dosya bağlantısı panoya kopyalandı!");
        _addTranslation("Pausing download ...", "indirme duraklatılıyor ...");
        _addTranslation("Pausing upload ...", "yükleme duraklatılıyor ...");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "Dosya başarıyla indirildi! (Dosya Bütünlük kontrolünü GEÇTİ)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "Dosya başarıyla indirildi! (ancak dosya bütünlük kontrolü İPTAL EDİLDİ)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "YÜKLEME BAŞARISIZ! (Boş tamamlama işleyicisi!)");
        _addTranslation("UPLOAD FAILED: too many errors", "YÜKLEME BAŞARISIZ: çok fazla hata");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "YÜKLEME BAŞARISIZ: ÖNEMLİ HATA");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "KÖTÜ HABER :( Dosya HASARLI!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "MEGA LINK GEÇİCİ OLARAK KULLANILAMAZ!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "Dosya geçici olarak kullanılamıyor! (Yeniden deneniyor");
        _addTranslation(" secs...)", " saniye...");
        _addTranslation(" (Retrying in ", " (Yeniden deneniyor ");
        _addTranslation("Proxy settings", "Proxy ayarları");
        _addTranslation("Authentication", "Kimlik doğrulama");
        _addTranslation("Upload info", "Yükleme bilgisi");
        _addTranslation("Files", "Dosyalar");
        _addTranslation("Username:", "Kullanıcı Adı:");
        _addTranslation("Password:", "Şifre:");
        _addTranslation("Link was copied to clipboard!", "Bağlantı panoya kopyalandı!");
        _addTranslation("Checking if there are previous downloads, please wait...", "Daha önce indirme olup olmadığı kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Daha önce yükleme olup olmadığı kontrol ediliyor, lütfen bekleyin...");
        _addTranslation("Restore window", "Pencereyi geri yükle");
        _addTranslation("EXIT", "UYGULAMAYI KAPAT");
        _addTranslation("File successfully downloaded!", "Dosya başarıyla indirildi!");
        _addTranslation("Quota used: ", "Kullanılan kota: ");
        _addTranslation("Streaming server: ON (port ", "Akış sunucusu: AÇIK (bağlantı noktası ");
        _addTranslation("MC reverse mode: ON (port ", "MC ters modu: AÇIK (bağlantı noktası ");
        _addTranslation("Joining file chunks, please wait...", "Dosya parçaları birleştiriliyor, lütfen bekleyin...");
        _addTranslation("Close MegaBasterd when all transfers finish", "Tüm transferler bittiğinde MegaBasterd'ı kapatın");
        _addTranslation("Use custom temporary directory for chunks storage", "Birleştirmeler için özel geçici depolama dizini kullanın");
        _addTranslation("CANCEL ALL DOWNLOADS", "TÜM İNDİRMELERİ İPTAL ET");
        _addTranslation("Save debug info to file", "Hata ayıklama bilgilerini dosyaya kaydet");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "Bu proxy biçim listesini kullan: [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "Slot");
        _addTranslation("MC reverse mode: OFF", "Ters MC modu: KAPALI");
        _addTranslation("Pre:", "Hazırlık aşamasında:");
        _addTranslation("Pro:", "Pro:");
        _addTranslation("Wait:", "Bekleme aşamasında:");
        _addTranslation("Run:", "indirme aşamasında:");
        _addTranslation("Finish:", "Tamamlandı:");
        _addTranslation("Rem:", "Rem:");
        _addTranslation("Italian", "İtalyan");
        _addTranslation("Chinese", "Çince");
        _addTranslation("German", "Almanca");
        _addTranslation("Hungarian", "Hungarian");
        _addTranslation("Turkish", "Türkçe");
        _addTranslation("Streaming server: OFF (port ", "Akış sunucusu: KAPALI (bağlantı noktası ");
        _addTranslation("MC reverse mode: OFF (port ", "MC ters modu: KAPALI (bağlantı noktası ");
        _addTranslation("SmartProxy: ON (port ", "SmartProxy: AÇIK (bağlantı noktası");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: KAPALI (bağlantı noktası ");
        _addTranslation("Link Grabber", "Bağlantı Yakalayıcı");
        _addTranslation("Select DLC container", "DLC birimini seçin");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "MEGA hesabı yok (Ayarlar > Hesaplar'a gidin");
        _addTranslation("MEGA API KEY", "MEGA API ANAHTARI");
        _addTranslation("MEGA API KEY ERROR", "MEGA API ANAHTARI HATASI");
        _addTranslation("An older version of MegaBasterd has been detected)", "MegaBasterd'ın daha eski bir sürümü tespit edildi");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", "\nÖnceki sürümden tüm mevcut ayarları ve aktarımları içe aktarmak istiyor musunuz?\nUYARI: VERSİYONLAR ARASINDA UYUMSUZLUKLAR OLABİLİR");
        _addTranslation("All your transferences have finished", "Tüm transferlerin tamamlandı");
        _addTranslation("Email", "Mail");
        _addTranslation("Host", "Sunucu");
        _addTranslation("User", "Kullanıcı");
        _addTranslation("Password", "Şifre");
        _addTranslation("API-KEY", "API-ANAHTARI");
        _addTranslation("Test", "Test");
        _addTranslation("OK", "TAMAM");
        _addTranslation("No", "Hayır");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Restore MegaBasterd window", "MegaBasterd penceresini geri yükle");
        _addTranslation("Exit from MegaBasterd", "MegaBasterd'den çıkış yap");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Used space: 0.00GB");
        _addTranslation("Open folder in browser", "Open folder in browser");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "CANCEL ALL DOWNLOADS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "MEGA ACCOUNTS ARE LOCKED");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORT ACCOUNTS (FILE)");
        _addTranslation("Monitor clipboard looking for new links", "Monitor clipboard looking for new links");
        _addTranslation("SURE?", "SURE?");
    }

    private void Spanish() {
        _addTranslation("FILE INTEGRITY IS OK", "LA INTEGRIDAD DEL ARCHIVO ES CORRECTA");
        _addTranslation("FILE INTEGRITY CHECK FAILED", "FALLÓ LA VERIFICACIÓN DE INTEGRIDAD DEL ARCHIVO");
        _addTranslation("CHECKING FILE INTEGRITY, please wait...", "COMPROBANDO INTEGRIDAD DEL ARCHIVO, por favor espera...");
        _addTranslation("GENERATING SHA1, please wait...", "GENERANDO SHA1, por favor espera...");
        _addTranslation("COPY ALL", "COPIAR TODO");
        _addTranslation("ALL COPIED!", "¡TODO COPIADO!");
        _addTranslation("FILE WITH SAME NAME AND SIZE ALREADY EXISTS", "YA EXISTE UN FICHERO CON EL MISMO NOMBRE Y TAMAÑO");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE. YOU SHOULD GET A KEY -> https://mega.nz/sdk", "AVISO: USAR LA API DE MEGA SIN UNA API KEY PUEDE VIOLAR SUS TÉRMINOS DE USO. DEBES CONSEGUIR UNA API KEY -> https://mega.nz/sdk");
        _addTranslation("WARNING: USING MEGA API WITHOUT API KEY MAY VIOLATE ITS TERM OF USE.\n\nYOU SHOULD GET A KEY -> https://mega.nz/sdk (and set it in MegaBasterd ADVANCED SETTINGS).\n\nCREATE API KEY NOW?", "AVISO: USAR LA API DE MEGA SIN UNA API KEY PUEDE VIOLAR SUS TÉRMINOS DE USO.\n\nDEBES CONSEGUIR UNA API KEY -> https://mega.nz/sdk (e introducirla en AJUSTES AVANZADOS de MegaBasterd).\n\n¿CREAR AHORA UNA API KEY?");
        _addTranslation("WARNING: Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use. USE THIS OPTION AT YOUR OWN RISK.", "AVISO: El uso de proxies o VPN para saltar el límite diario de descarga de MEGA podría violar sus Términos de Uso. UTILIZA ESTA OPCIÓN BAJO TU RESPONSABILIDAD.");
        _addTranslation("Using proxies or VPN to bypass MEGA's daily download limitation may violate its Terms of Use.\n\nUSE THIS OPTION AT YOUR OWN RISK.", "El uso de proxies o VPN para saltar el límite diario de descarga de MEGA podría violar sus Términos de Uso.\n\nUTILIZA ESTA OPCIÓN BAJO TU RESPONSABILIDAD.");
        _addTranslation("Execute this command when MEGA download limit is reached:", "Ejecutar este comando cuando se alcance el límite de descarga de MEGA:");
        _addTranslation("Use this proxy list (instead of the one included in MegaBasterd) Format is [*]IP:PORT[@user_b64:password_b64]", "Usar esta lista de proxys (en vez de la incluida en MegaBasterd) El formato es [*]IP:PUERTO[@usuario_b64:password_b64]");
        _addTranslation("Waiting for completion handler ... ***DO NOT EXIT MEGABASTERD NOW***", "Esperando manejador de finalización ... ***NO CIERRES MEGABASTERD EN ESTE MOMENTO***");
        _addTranslation("Finishing calculating CBC-MAC code (this could take a while) ... ***DO NOT EXIT MEGABASTERD NOW***", "Terminando de calcular código CBC-MAC (esto podría llevar tiempo) ... ***NO CIERRES MEGABASTERD EN ESTE MOMENTO***");
        _addTranslation("Split content in different uploads", "Separar contenido en diferentes subidas");
        _addTranslation("Merge content in the same upload", "Juntar todo en la misma subida");
        _addTranslation("How do you want to proceed?", "¿Qué quieres hacer?");
        _addTranslation("Put on TOP of waiting queue", "Poner en lo alto de la cola de espera");
        _addTranslation("TOP", "ENCIMA DE TODO");
        _addTranslation("BOTTOM", "DEBAJO DE TODO");
        _addTranslation("Freeze transferences before start", "Congelar transferencias antes de empezar");
        _addTranslation("UNFREEZE WAITING TRANSFERENCES", "DESCONGELAR TRANSFERENCIAS A LA ESPERA");
        _addTranslation("(FROZEN) Waiting to start...", "(CONGELADA) Esperando para empezar...");
        _addTranslation("(FROZEN) Waiting to start (", "(CONGELADA) Esperando para empezar (");
        _addTranslation("There are a lot of files in this folder.\nNot all links will be provisioned at once to avoid saturating MegaBasterd", "Hay muchos archivos en esta carpeta.\nNo se aprovisionarán todos los enlaces de una vez para evitar saturar MegaBasterd");
        _addTranslation("You've tried to login too many times. Wait an hour.", "Has intentado hacer login demasiadas veces. Prueba dentro de una hora.");
        _addTranslation("MEGA LINK ERROR!", "¡ENLACE DE MEGA ERRÓNEO!");
        _addTranslation("Please enter 2FA PIN CODE", "Por favor, introduce el CÓDIGO 2FA");
        _addTranslation("Enable log file", "Activar fichero de log");
        _addTranslation("Font:", "Fuente:");
        _addTranslation("Loading...", "Cargando...");
        _addTranslation("DEFAULT", "POR DEFECTO");
        _addTranslation("ALTERNATIVE", "ALTERNATIVA");
        _addTranslation("Download latest version", "Descargar la última versión");
        _addTranslation("PROVISION FAILED", "ERROR AL APROVISIONAR");
        _addTranslation("Error registering download: file is already downloading.", "Error al registrar la descarga: el archivo ya se está descargando.");
        _addTranslation("FATAL ERROR! ", "¡ERROR FATAL! ");
        _addTranslation("ERROR: FILE NOT FOUND", "ERROR: ARCHIVO NO ENCONTRADO");
        _addTranslation("Mega link is not valid! ", "Enlace de MEGA incorrecto! ");
        _addTranslation("Checking your MEGA accounts, please wait...", "Comprobando tus cuentas de MEGA, por favor espera...");
        _addTranslation("Check for updates", "Comprobar actualización");
        _addTranslation("Checking, please wait...", "Comprobando, por favor espera...");
        _addTranslation("You have the latest version ;)", "Tienes la versión más reciente ;)");
        _addTranslation("Copy MegaBasterd download URL", "Copiar la URL de descarga de MegaBasterd");
        _addTranslation("Made with love (and with no warranty) by tonikelope.", "Fabricado con amor (y sin ninguna garantía) por tonikelope.");
        _addTranslation("Yet another unofficial (and ugly) cross-platform MEGA downloader/uploader/streaming suite.", "Ni más ni menos que otra suite multiplataforma no oficial (y fea) de descarga/subida/streaming para MEGA.");
        _addTranslation("MEGA URL was copied to clipboard!", "¡URL de MEGA copiada en el portapapeles!");
        _addTranslation("MegaBasterd NEW VERSION is available! -> ", "¡Hay una versión nueva de MegaBasterd disponible! -> ");
        _addTranslation("Selecting folder...", "Seleccionando carpeta...");
        _addTranslation("MERGE FILE", "JUNTAR ARCHIVO");
        _addTranslation("Delete parts after merge", "Eliminar partes después de juntar");
        _addTranslation("Remove selected", "Quitar seleccionado");
        _addTranslation("SPLIT FILE/s", "PARTIR ARCHIVO/s");
        _addTranslation("Encrypt on disk sensitive information", "Cifrar en disco datos sensibles");
        _addTranslation("Allow using MEGA accounts for download/streaming", "Permitir utilizar cuentas de MEGA para descargar/streaming");
        _addTranslation("Please wait...", "Por favor espera...");
        _addTranslation("CANCEL RETRY", "CANCELAR REINTENTO");
        _addTranslation("SPLITTING FILE...", "PARTIENDO ARCHIVO...");
        _addTranslation("Open folder", "Abrir carpeta");
        _addTranslation("RESUME DOWNLOAD", "CONTINUAR DESCARGA");
        _addTranslation("Close", "Cerrar");
        _addTranslation("Add files", "Agregar archivos");
        _addTranslation("IMPORT SETTINGS", "IMPORTAR AJUSTES");
        _addTranslation("RESET MEGABASTERD", "RESETEAR MEGABASTERD");
        _addTranslation("RESET ACCOUNTS", "RESETEAR CUENTAS");
        _addTranslation("Verify file integrity (when download is finished)", "Verificar integridad del archivo (al terminar la descarga)");
        _addTranslation("Let's dance, baby", "¡Vamos!");
        _addTranslation("Unlock accounts", "Desbloquear cuentas");
        _addTranslation("Use MegaCrypter reverse mode", "Utilizar modo inverso de MegaCrypter");
        _addTranslation("Select (any) file part", "Seleccionar (alguna) parte del archivo");
        _addTranslation("Add folder", "Añadir una carpeta");
        _addTranslation("Adding files, please wait...", "Añadiendo archivos, por favor espera...");
        _addTranslation("Restart", "Reiniciar");
        _addTranslation("Use SmartProxy", "Utilizar SmartProxy");
        _addTranslation("PAUSE DOWNLOAD", "PAUSAR DESCARGA");
        _addTranslation("Change it", "Cambiar");
        _addTranslation("EXPORT SETTINGS", "EXPORTAR AJUSTES");
        _addTranslation("Change output folder", "Cambiar carpeta destino");
        _addTranslation("Add account", "Añadir cuenta");
        _addTranslation("Select file/s", "Seleccionar archivo/s");
        _addTranslation("Opening file...", "Abriendo archivo...");
        _addTranslation("CANCEL DOWNLOAD", "CANCELAR DESCARGA");
        _addTranslation("REMOVE ALL EXCEPT THIS", "QUITAR TODO EXCEPTO ESTO");
        _addTranslation("Loading DLC, please wait...", "Cargando DLC, por favor espera...");
        _addTranslation("Changing output folder...", "Cambiando carpeta destino...");
        _addTranslation("RESUME UPLOAD", "CONTINUAR SUBIDA");
        _addTranslation("Limit upload speed", "Limitar velocidad de subida");
        _addTranslation("CANCEL", "CANCELAR");
        _addTranslation("Use multi slot download mode", "Utilizar descarga multi slot");
        _addTranslation("Selecting file...", "Seleccionando archivo...");
        _addTranslation("Copy folder link", "Copiar enlace de carpeta");
        _addTranslation("Limit download speed", "Limitar velocidad de descarga");
        _addTranslation("REMOVE THIS", "QUITAR ESTO");
        _addTranslation("Copy file link", "Copiar enlace de archivo");
        _addTranslation("Load DLC container", "Cargar contenedor DLC");
        _addTranslation("Adding folder, please wait...", "Añadiendo carpeta, por favor espera...");
        _addTranslation("PAUSE UPLOAD", "PAUSAR SUBIDA");
        _addTranslation("CANCEL CHECK", "CANCELAR VERIFICACIÓN");
        _addTranslation("Keep temp file", "Conservar archivo temporal");
        _addTranslation("Use HTTP(S) PROXY", "Utilizar PROXY HTTP(S)");
        _addTranslation("MERGING FILE...", "JUNTANDO ARCHIVO...");
        _addTranslation("Checking MEGA account...", "Comprobando cuenta de MEGA...");
        _addTranslation("SAVE", "GUARDAR");
        _addTranslation("New download", "Nueva descarga");
        _addTranslation("New upload", "Nueva subida");
        _addTranslation("New streaming", "Nuevo streaming");
        _addTranslation("Split file", "Partir un archivo");
        _addTranslation("Merge file", "Juntar las partes de un archivo");
        _addTranslation("Remove all no running downloads", "Cancelar las descargas no activas");
        _addTranslation("Remove all no running uploads", "Cancelar las subidas no activas");
        _addTranslation("Edit", "Edición");
        _addTranslation("Settings", "Ajustes");
        _addTranslation("Help", "Ayuda");
        _addTranslation("About", "Acerca de");
        _addTranslation("Remember for this session", "Recordar durante la sesión");
        _addTranslation("Restore folder data", "Restaurar contenido de la carpeta");
        _addTranslation("Restoring data, please wait...", "Restaurando datos, por favor espera...");
        _addTranslation("File", "Archivo");
        _addTranslation("Hide to tray", "Ocultar en la bandeja");
        _addTranslation("Clear finished", "Cerrar las que finalizaron");
        _addTranslation("Exit", "Salir");
        _addTranslation("Default slots per file:", "Slots por archivo por defecto:");
        _addTranslation("Note: if you want to download without using a MEGA PREMIUM account you SHOULD enable it. (Slots consume RAM, so use them moderately).", "Nota: si quieres descargar sin utilizar una cuenta de MEGA PREMIUM es recomendable activarlo. (Los slots consumen RAM, así que úsalos con moderación).");
        _addTranslation("Max speed (KB/s):", "Velocidad máxima (KB/s):");
        _addTranslation("Default account:", "Cuenta por defecto:");
        _addTranslation("TCP Port:", "Puerto TCP:");
        _addTranslation("Note: you MUST \"OPEN\" this port in your router/firewall.", "Nota: es OBLIGATORIO \"ABRIR\" este puerto en tu router/firewall.");
        _addTranslation("Note: enable it in order to mitigate bandwidth limit. (Multi slot required).", "Nota: actívalo para mitigar el límite de descarga de MEGA. (Se requiere muti slot).");
        _addTranslation("Max parallel downloads:", "Máximas descargas simultáneas:");
        _addTranslation("Max parallel uploads:", "Máximas subidas simultáneas:");
        _addTranslation("Note: slots consume RAM, so use them moderately.", "Nota: los slots consumen RAM, así que úsalos con moderación");
        _addTranslation("Note: you can use a (optional) alias for your email addresses -> bob@supermail.com#bob_mail (don't forget to save after entering your accounts).", "Nota: puedes usar de forma opcional un alias para tus emails -> bob@supermail.com#bob_mail (no te olvides de guardar después de introducir todas tus cuentas).");
        _addTranslation("Your MEGA accounts:", "Tus cuentas de MEGA:");
        _addTranslation("Your ELC accounts:", "Tus cuentas ELC:");
        _addTranslation("Note: restart required.", "Nota: es necesario reiniciar.");
        _addTranslation("Note: restart might be required.", "Nota: podría ser necesario reiniciar.");
        _addTranslation("Font ZOOM (%):", "Zoom de la fuente (%):");
        _addTranslation("Note: MegaBasterd will use this proxy for ALL connections.", "Nota: MegaBasterd utilizará este proxy para todas las conexiones.");
        _addTranslation("Port:", "Puerto:");
        _addTranslation("Settings successfully saved!", "¡Ajustes guardados correctamente!");
        _addTranslation("Settings successfully imported!", "¡Ajustes importados correctamente!");
        _addTranslation("Settings successfully exported!", "¡Ajustes exportados correctamente!");
        _addTranslation("Settings successfully reset!", "¡Ajustes reseteados correctamente!");
        _addTranslation("There were errors with some accounts (email and/or password are/is wrong). Please, check them:\n\n", "Hay errores con algunas cuentas (email y/o contraseña incorrectos). Por favor, revísalas:\n\n");
        _addTranslation("Settings saved", "Ajustes guardados");
        _addTranslation("Settings imported", "Ajustes importados");
        _addTranslation("Settings exported", "Ajustes exportados");
        _addTranslation("Settings reset", "Ajustes reseteados");
        _addTranslation("MegaBasterd will restart", "MegaBasterd se reiniciará");
        _addTranslation("Restart required", "Es necesario reiniciar");
        _addTranslation("File is not readable!", "¡Archivo no accesible!");
        _addTranslation("Folder is not readable!", "¡Carpeta no accesible!");
        _addTranslation("BAD PASSWORD!", "¡CONTRASEÑA INCORRECTA!");
        _addTranslation("Passwords does not match!", "¡Las contraseñas no coinciden!");
        _addTranslation("Please, paste a Mega/MegaCrypter/ELC link!", "Por favor, escribe un enlace de Mega/MegaCrypter/ELC");
        _addTranslation("Yes", "Sí");
        _addTranslation("Cancel", "Cancelar");
        _addTranslation("UNEXPECTED ERROR!", "¡ERROR INESPERADO!");
        _addTranslation("It seems MegaBasterd is streaming video. Do you want to exit?", "Parece que MegaBasterd está retransmitiendo vídeo. ¿Quieres continuar?");
        _addTranslation("It seems MegaBasterd is provisioning down/uploads.\n\nIf you exit now, unprovisioned down/uploads will be lost.\n\nDo you want to continue?", "Parece que MegaBasterd está provisionando transferencias.\n\nSi sales ahora, todas las transferencias no provisionadas se perderán.\n\n¿Quieres continuar?");
        _addTranslation("It seems MegaBasterd is just finishing uploading some files.\n\nIF YOU EXIT NOW, THOSE UPLOADS WILL FAIL.\n\nDo you want to continue?", "Parece que MegaBasterd está finalizando unas subidas.\n\nSI SALES AHORA, ESAS SUBIDAS FALLARÁN.\n\n¿Quieres continuar?");
        _addTranslation("All your current settings and accounts will be deleted after import. (It is recommended to export your current settings before importing). \n\nDo you want to continue?", "Todos tus ajustes y cuentas actuales se perderán después de importar. (Es recomendable guardar tus ajustes actuales antes de importar otros). ¿Quieres continuar?");
        _addTranslation("Only SAVED settings and accounts will be exported. (If you are unsure, it is better to save your current settings and then export them).\n\nDo you want to continue?", "Sólamente los ajustes GUARDADOS se exportarán. (Si no estás seguro, es mejor que guardes antes tus ajustes y que después vuelvas aquí). ¿Quieres continuar?");
        _addTranslation("Master password will be reset and all your accounts will be removed. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "La contraseña maestra será reseteada y todas tus cuentas serán eliminadas. (ESTO NO SE PUEDE DESHACER).\n\n¿Quieres continuar?");
        _addTranslation("ALL YOUR SETTINGS, ACCOUNTS AND TRANSFERENCES WILL BE REMOVED. (THIS CAN'T BE UNDONE)\n\nDo you want to continue?", "TODOS TUS AJUSTES, CUENTAS Y TRANSFERENCIAS SERÁN ELIMINADAS. (ESTO NO SE PUEDE DESHACER)\n\n¿Quieres continuar?");
        _addTranslation("Remove all no running downloads?", "¿Eliminar todas las descargas que no están en ejecución?");
        _addTranslation("Warning!", "¡Atención!");
        _addTranslation("Remove all no running uploads?", "¿Eliminar todas las subidas que no están en ejecución?");
        _addTranslation("Please, enter your master password", "Por favor, ingresa tu contraseña maestra");
        _addTranslation("WARNING: if you forget this password, you will have to insert all your accounts again.", "AVISO: si olvidas esta contraseña, tendrás que volver a insertar todas tus cuentas.");
        _addTranslation("New pass:", "Nueva contraseña:");
        _addTranslation("Confirm new:", "Confirmar nueva contraseña:");
        _addTranslation("Verifying your password, please wait...", "Verificando tu contraseña, por favor espera...");
        _addTranslation("Processing your password, please wait...", "Procesando tu contraseña, por favor espera...");
        _addTranslation("Downloads", "Descargas");
        _addTranslation("Uploads", "Subidas");
        _addTranslation("Accounts", "Cuentas");
        _addTranslation("Advanced", "Avanzado");
        _addTranslation("Language:", "Idioma:");
        _addTranslation("English", "Inglés");
        _addTranslation("Spanish", "Español");
        _addTranslation("Loading files, please wait...", "Cargando ficheros, por favor espera...");
        _addTranslation("Checking account quota, please wait...", "Comprobando espacio utilizado de la cuenta, por favor espera...");
        _addTranslation("ERROR checking account quota!", "ERROR al comprobar el espacio utilizado.");
        _addTranslation("If you DO NOT want to transfer some folder or file you can REMOVE it (to select several items at the same time use CTRL + LMOUSE).", "Si no quieres transferir alguna carpeta o archivo puedes quitarlo de la lista (para seleccionar varios elementos al mismo tiempo usa CTRL + RATÓN_IZQ)");
        _addTranslation("Upload name:", "Nombre de la subida:");
        _addTranslation("Account:", "Cuenta:");
        _addTranslation("Folder link detected!", "¡Enlace de carpeta detectado!");
        _addTranslation("File already exists!", "¡El archivo ya existe!");
        _addTranslation("Megabasterd is stopping transferences safely, please wait...", "MegaBasterd está deteniendo las transferencias de forma segura, por favor espera...");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link/s here (one per line):", "Pon aquí tus enlaces de MEGA/MegaCrypter/ELC (uno por línea):");
        _addTranslation("Download folder:", "Carpeta de descarga:");
        _addTranslation("Split size (MBs):", "Tamaño de cada parte (MBs):");
        _addTranslation("File successfully splitted!", "¡Archivo partido correctamente!");
        _addTranslation("File successfully merged!", "¡Archivo juntado correctamente!");
        _addTranslation("File successfuly downloaded!", "¡Archivo descargado correctamente!");
        _addTranslation("Download paused!", "¡Descarga pausada!");
        _addTranslation("Downloading file from mega ...", "Descargando archivo de mega ...");
        _addTranslation("Copy link", "Copiar enlace");
        _addTranslation("Downloading file from mega ", "Descargando archivo de mega ");
        _addTranslation("EXIT NOW", "SALIR AHORA MISMO");
        _addTranslation("Download CANCELED!", "¡Descarga CANCELADA!");
        _addTranslation("Upload CANCELED!", "¡Subida CANCELADA!");
        _addTranslation("Uploading file to mega (", "Subiendo archivo a mega (");
        _addTranslation("Put your MEGA/MegaCrypter/ELC link here in order to get a streaming link:", "Pon aquí tu enlace de MEGA/MegaCrypter/ELC para conseguir un enlace de streaming:");
        _addTranslation("Use this account for streaming:", "Usar esta cuenta para streaming:");
        _addTranslation("Use this account for download:", "Usar esta cuenta para descargar:");
        _addTranslation("Streaming link was copied to clipboard!\nRemember to keep MegaBasterd running in background while playing content.", "¡Enlace de streaming copiado al portapapeles!\nRecuerda dejar abierto MegaBasterd mientras se reproduce el contenido.");
        _addTranslation("CANCEL UPLOAD", "CANCELAR SUBIDA");
        _addTranslation("Upload paused!", "¡Subida pausada!");
        _addTranslation("Stopping download safely before exit MegaBasterd, please wait...", "Deteniendo descarga de forma segura antes de salir, por favor espera...");
        _addTranslation("Stopping upload safely before exit MegaBasterd, please wait...", "Deteniendo subida de forma segura antes de salir, por favor espera...");
        _addTranslation("Starting download, please wait...", "Empezando descarga, por favor espera...");
        _addTranslation("Starting upload, please wait...", "Empezando subida, por favor espera...");
        _addTranslation("Starting download (retrieving MEGA temp link), please wait...", "Empezando descarga (pidiendo enlace temporal de MEGA), por favor espera...");
        _addTranslation("File exists, resuming download...", "El archivo existe, continuando descarga...");
        _addTranslation("Truncating temp file...", "Truncando fichero temporal...");
        _addTranslation("Waiting to check file integrity...", "Esperando para verificar integridad del archivo...");
        _addTranslation("Checking file integrity, please wait...", "Verificando integridad del archivo...");
        _addTranslation("Provisioning download, please wait...", "Aprovisionando descarga, por favor espera...");
        _addTranslation("Waiting to start...", "Esperando para empezar...");
        _addTranslation("Provisioning upload, please wait...", "Aprovisionando subida, por favor espera...");
        _addTranslation("Waiting to start (", "Esperando para empezar (");
        _addTranslation("Creating new MEGA node ... ***DO NOT EXIT MEGABASTERD NOW***", "Creando nuevo nodo de MEGA ... ***NO CIERRES MEGABASTERD EN ESTE MOMENTO***");
        _addTranslation("File successfully uploaded! (", "¡Archivo subido correctamente! (");
        _addTranslation("PAUSE ALL", "PAUSAR TODO");
        _addTranslation("RESUME ALL", "CONTINUAR TODO");
        _addTranslation("MEGA folder link was copied to clipboard!", "¡Enlace de carpeta de MEGA copiado al portapapeles!");
        _addTranslation("MEGA file link was copied to clipboard!", "¡Enlace de fichero de MEGA copiado al portapapeles!");
        _addTranslation("Pausing download ...", "Pausando descarga ...");
        _addTranslation("Pausing upload ...", "Pausando subida ...");
        _addTranslation("File successfully downloaded! (Integrity check PASSED)", "¡Archivo descargado correctamente! (Test de integridad CORRECTO)");
        _addTranslation("File successfully downloaded! (but integrity check CANCELED)", "¡Archivo descargado correctamente! (Test de integridad cancelado)");
        _addTranslation("UPLOAD FAILED! (Empty completion handler!)", "¡SUBIDA FALLIDA! (Manejador de finalización vacío)");
        _addTranslation("UPLOAD FAILED: too many errors", "LA SUBIDA FALLÓ: demasiados errores");
        _addTranslation("UPLOAD FAILED: FATAL ERROR", "LA SUBIDA FALLÓ: ERROR FATAL");
        _addTranslation("BAD NEWS :( File is DAMAGED!", "MALAS NOTICIAS :( El archivo está corrupto!");
        _addTranslation("MEGA LINK TEMPORARILY UNAVAILABLE!", "¡ENLACE TEMPORALMENTE NO DISPONIBLE!");
        _addTranslation("File temporarily unavailable! (Retrying in ", "¡Archivo temporalmente no disponible! (Reintentando en ");
        _addTranslation(" secs...)", " segundos...)");
        _addTranslation(" (Retrying in ", " (Reintentando en ");
        _addTranslation("Proxy settings", "Ajustes de proxy");
        _addTranslation("Authentication", "Autenticación");
        _addTranslation("Upload info", "Información de la subida");
        _addTranslation("Files", "Archivos");
        _addTranslation("Username:", "Usuario:");
        _addTranslation("Password:", "Contraseña:");
        _addTranslation("Link was copied to clipboard!", "¡Enlace copiado al portapapeles!");
        _addTranslation("Checking if there are previous downloads, please wait...", "Comprobando si existen descargas previas, por favor espera...");
        _addTranslation("Checking if there are previous uploads, please wait...", "Comprobando si existen subidas previas, por favor espera...");
        _addTranslation("Restore window", "Restaurar ventana");
        _addTranslation("EXIT", "SALIR");
        _addTranslation("File successfully downloaded!", "¡Archivo descargado correctamente!");
        _addTranslation("Quota used: ", "Espacio usado: ");
        _addTranslation("Streaming server: ON (port ", "Servidor de streaming: ON (puerto ");
        _addTranslation("MC reverse mode: ON (port ", "MC reverse mode: ON (puerto ");
        _addTranslation("Joining file chunks, please wait...", "Juntando chunks, por favor espera...");
        _addTranslation("Close MegaBasterd when all transfers finish", "Cerrar MegaBasterd cuando todas las transferencias terminen");
        _addTranslation("Use custom temporary directory for chunks storage", "Usar un directorio temporal personalizado para almacenar los chunks");
        _addTranslation("CANCEL ALL DOWNLOADS", "CANCELAR TODAS LAS DESCARGAS");
        _addTranslation("Save debug info to file", "Generar fichero de depuración");
        _addTranslation("Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]", "Use this proxy list Format is [*]IP:PORT[@user_b64:password_b64]");
        _addTranslation("Slots", "Slots");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Pre:", "Pre:");
        _addTranslation("Pro:", "Cargando:");
        _addTranslation("Wait:", "Espera:");
        _addTranslation("Run:", "Transf:");
        _addTranslation("Finish:", "Fin:");
        _addTranslation("Rem:", "Pend:");
        _addTranslation("Italian", "Italiano");
        _addTranslation("Chinese", "Chino");
        _addTranslation("German", "Alemán");
        _addTranslation("Hungarian", "Hungarian");
        _addTranslation("Turkish", "Turco");
        _addTranslation("Streaming server: OFF (port ", "Streaming server: OFF (port ");
        _addTranslation("MC reverse mode: OFF (port ", "MC reverse mode: OFF (port ");
        _addTranslation("SmartProxy: ON (port ", "SmartProxy: ON (port ");
        _addTranslation("SmartProxy: OFF (port ", "SmartProxy: OFF (port ");
        _addTranslation("Link Grabber", "Link Grabber");
        _addTranslation("Select DLC container", "Select DLC container");
        _addTranslation("No MEGA accounts available (Go to Settings > Accounts)", "No MEGA accounts available (Go to Settings > Accounts)");
        _addTranslation("MEGA API KEY:", "MEGA API KEY:");
        _addTranslation("MEGA API KEY ERROR", "MEGA API KEY ERROR");
        _addTranslation("An older version of MegaBasterd has been detected (", "An older version of MegaBasterd has been detected (");
        _addTranslation(").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.", ").\nDo you want to import all current settings and transfers from the previous version?\nWARNING: INCOMPATIBILITIES MAY EXIST BETWEEN VERSIONS.");
        _addTranslation("All your transferences have finished", "All your transferences have finished");
        _addTranslation("Email", "Email");
        _addTranslation("Host", "Host");
        _addTranslation("User", "User");
        _addTranslation("Password", "Password");
        _addTranslation("API-KEY", "API-KEY");
        _addTranslation("Test", "Test");
        _addTranslation("OK", "OK");
        _addTranslation("No", "No");
        _addTranslation("MC reverse mode: OFF", "MC reverse mode: OFF");
        _addTranslation("Restore MegaBasterd window", "Restore MegaBasterd window");
        _addTranslation("Exit from MegaBasterd", "Exit from MegaBasterd");
        _addTranslation("Vietnamese", "Vietnamese");
        _addTranslation("Used space: 0.00GB", "Used space: 0.00GB");
        _addTranslation("Open folder in browser", "Abrir carpeta en navegador");
        _addTranslation("Creating thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Creando thumbnail ... ***NO CIERRES MEGABASTERD EN ESTE MOMENTO***");
        _addTranslation("Uploading thumbnail ... ***DO NOT EXIT MEGABASTERD NOW***", "Subiendo thumbnail ... ***NO CIERRES MEGABASTERD EN ESTE MOMENTO***");
        _addTranslation("CANCEL ALL DOWNLOADS?", "¿CANCELAR TODAS LAS DESCARGAS?");
        _addTranslation("MEGA ACCOUNTS ARE LOCKED", "LA LISTA DE CUENTAS DE MEGA ESTÁ BLOQUEADA");
        _addTranslation("IMPORT ACCOUNTS (FILE)", "IMPORTAR CUENTAS (FICHERO)");
        _addTranslation("Monitor clipboard looking for new links", "Vigilar portapapeles en busca de enlaces nuevos");
        _addTranslation("SURE?", "SEGURO?");

    }

    private void _addTranslation(String key, String val) {

        if (_rosetta.putIfAbsent(key, val) != null) {

            Logger.getLogger(MainPanel.class.getName()).log(Level.WARNING, "Rosetta: {0} aready exists!", new Object[]{key});
        }
    }

    public String translate(String orig) {

        return (orig != null && _rosetta.containsKey(orig)) ? _rosetta.get(orig) : orig;
    }

    private static class LazyHolder {

        private static final LabelTranslatorSingleton INSTANCE = new LabelTranslatorSingleton();

        private LazyHolder() {
        }
    }
}
